package com.kronoscards.fragments;

import android.graphics.Color;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.kronoscards.pack.ResultatPartida;

public class Fragment_EndGame  extends Fragment {
	
	 MainActivity p;
	 View view;
	 int puntuacioTotal=0;
	 ResultatPartida resultPartida;
	 
	 @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_endgame, container, false);
		       p=(MainActivity) getActivity();
		       p.setNumFragment(4);
		       resultPartida=p.getPuntuacioLastPartida();
		       OutlineTextView titulo=(OutlineTextView)view.findViewById(R.id.titulo);
		       titulo.setTypeface(p.getAppValors().getTipoPacifico());
		       titulo.setTextColor(Color.argb(255, 0, 197, 0));	
		       TextView tituloPuntuacionTotal=(TextView)view.findViewById(R.id.titulopuntuaciontotal);
		       tituloPuntuacionTotal.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView tituloPuntuacionPartida=(TextView)view.findViewById(R.id.puntuaciopartida);
		       tituloPuntuacionPartida.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView tituloWin=(TextView)view.findViewById(R.id.titwin);
		       tituloWin.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView qttWin=(TextView)view.findViewById(R.id.valuewin);
		       qttWin.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView tituloPerfect=(TextView)view.findViewById(R.id.titperfect);
		       tituloPerfect.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView qttPerfectValue=(TextView)view.findViewById(R.id.valueperfect);
		       qttPerfectValue.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView qttPuntuacionTotal=(TextView)view.findViewById(R.id.valuepuntuaciontotal);
		       qttPuntuacionTotal.setTypeface(p.getAppValors().getTipoMyriad());
		       TextView qttPuntuacionPartida=(TextView)view.findViewById(R.id.valuepuntuacionpartida);
		       qttPuntuacionPartida.setTypeface(p.getAppValors().getTipoMyriad());
		       
		       Button aceptar=(Button)view.findViewById(R.id.button_aceptar);
		       aceptar.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					savePuntuacio();
					p.returnFragmentMainScreen();
						
				}		    	   
		       });
		       if (resultPartida!=null)
		       {
		    	   int puntuacioPartida=resultPartida.getPuntuacioTotal();
		    	   qttPuntuacionPartida.setText(""+puntuacioPartida);
		    	   if (resultPartida.isWinner())
			       {
		    		   puntuacioPartida=puntuacioPartida+100;
		    		   qttWin.setText("+100");
			       }
		    	   if (resultPartida.isPerfect())
		    	   {
		    		   puntuacioPartida=puntuacioPartida+50;
		    		   qttPerfectValue.setText("+50");
		    	   }
			       puntuacioTotal=p.getAppValors().getPrefsKC().getInt("puntuacio", 0)+puntuacioPartida;
			       qttPuntuacionTotal.setText(""+puntuacioPartida);
			       titulo.setText(p.getString(R.string.kronoscards_endgame_titulo)+" "+puntuacioTotal);
		       }else
		       {
		    	   qttPuntuacionTotal.setText("0");
		    	   qttPuntuacionPartida.setText("0");
		    	   titulo.setText(""+p.getAppValors().getPrefsKC().getInt("puntuacio", 0));
		       }
		       return view;
	 }
	 private void savePuntuacio()
	 {
		 p.getAppValors().getPrefsKC().edit().putInt("puntuacio", puntuacioTotal).commit();
	 }
	 public void backPressed() {
		 savePuntuacio();
			p.returnFragmentMainScreen();
			
		}

}
