package com.kronoscards.fragments;



import java.util.Timer;
import java.util.TimerTask;

import com.kronoscards.adaptscreen.AutoResizeTextView;
import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.adaptscreen.SeekArcCrono;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.kronoscards.pack.SoundManagerGeneral;
import com.nineoldandroids.animation.Animator;
import com.nineoldandroids.animation.AnimatorListenerAdapter;
import com.nineoldandroids.animation.AnimatorSet;
import com.nineoldandroids.animation.ObjectAnimator;

import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Paint.Align;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.LinearInterpolator;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class Fragment_Heather extends Fragment {
	
	 MainActivity c;
	 View view;
	 ImageView btn_openRivalCards;
	 RelativeLayout relMiniCard;
	 ImageView minicard;
	 private SeekArcCrono mSeekArc;
	 int progress=60*100;
	 Timer myTimer;
	 MyTimerTask myTask;
	 OutlineTextView turnIndicator,timeIndicator;
	 float sizeTextTurnInit=0;
	 SoundManagerGeneral heatherSounds=new SoundManagerGeneral();
	 
	 private boolean isVisible=false;
	 ImageView cancelMiniCard;
	 private boolean finishCuentaAtras=false;
	 OutlineTextView missatgeAnimat;
	 OutlineTextView textInfo;
	 OutlineTextView rivalName,misCartas;
	 int tiempoTurno=60;
	 TextView miPuntuacionText,rivalPuntuacionText;
	 int miPuntuacion=0,rivalPuntuacion=0;
	  private boolean soundEnabled=true;
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_heather, container, false);
		       c=(MainActivity) getActivity();
		       if (soundEnabled)
				 {
			       heatherSounds.initSounds(c);
			       heatherSounds.addSound(1, R.raw.alarm_counter);
				 }
		       tiempoTurno=c.getFragmentTablero().getoPartida().getTiempoTurno();
		       mSeekArc = (SeekArcCrono)c.findViewById(R.id.seekArcCrono);
		       soundEnabled=c.getAppValors().getPrefsKC().getBoolean("sonido", true);
		       if (c.getAppValors().isXhdpi()) mSeekArc.setProgressWidth(15);
		       else if (c.getAppValors().isHdpi()) mSeekArc.setProgressWidth(10);
		       progress=tiempoTurno*100;
				mSeekArc.setMax(tiempoTurno*100);
				 mSeekArc.setProgressColorNormal();
				mSeekArc.setClockwise(false);
				mSeekArc.setEnabled(false);
				mSeekArc.setProgress(tiempoTurno*100);
				minicard=(ImageView)c.findViewById(R.id.minicard);
				rivalName=(OutlineTextView)view.findViewById(R.id.rivalname);
				rivalName.setTypeface(c.getAppValors().getTipoPacifico());
				rivalName.setTextColor(Color.argb(255, 0, 197, 0));
				misCartas=(OutlineTextView)c.findViewById(R.id.miscardstext);
				misCartas.setTypeface(c.getAppValors().getTipoPacifico());
				misCartas.setTextColor(Color.argb(255, 0, 197, 0));	
				textInfo=(OutlineTextView)view.findViewById(R.id.textTurn);
				textInfo.setTypeface(c.getAppValors().getTipoPacifico());
				textInfo.setTextColor(Color.argb(255, 0, 197, 0));
				turnIndicator=(OutlineTextView)view.findViewById(R.id.turnIndicator);
				
				turnIndicator.setTextColor(Color.argb(255, 0, 197, 0));
				sizeTextTurnInit=turnIndicator.getTextSize();
		       turnIndicator.setIncludeFontPadding(false);
		       turnIndicator.setTypeface(c.getAppValors().getTipoPacifico());
		       timeIndicator=(OutlineTextView)c.findViewById(R.id.timeIndicator);
		       timeIndicator.setText(" "+tiempoTurno+" ");
		       timeIndicator.setTextColor(Color.argb(255, 0, 197, 0));
		       timeIndicator.setIncludeFontPadding(false);
		       timeIndicator.setTypeface(c.getAppValors().getTipoPacifico());
		       relMiniCard=(RelativeLayout)c.findViewById(R.id.relminicard);
		       relMiniCard.setVisibility(View.GONE);	
		     
		       cancelMiniCard=(ImageView)c.findViewById(R.id.cancelMiniCard);
				 cancelMiniCard.setOnClickListener(new OnClickListener(){
					@Override
					public void onClick(View v) {
						relMiniCard.setVisibility(View.GONE);
						c.getFragmentTablero().cancelMiniCard();
						
					}
					 
				 });
		       setTurnIndicator(0);
		       TextView titPuntuacio=(TextView)c.findViewById(R.id.titpuntuacio);
		       titPuntuacio.setTypeface(c.getAppValors().getTipoMyriad());
		       TextView titMiPuntuacio=(TextView)c.findViewById(R.id.titmipuntuacion);
		       titMiPuntuacio.setTypeface(c.getAppValors().getTipoMyriad());
		       TextView titRivalPuntuacio=(TextView)c.findViewById(R.id.rivalpuntuacio);
		       titRivalPuntuacio.setTypeface(c.getAppValors().getTipoMyriad());
		       miPuntuacionText=(TextView)c.findViewById(R.id.valuemipuntuacio);
		       miPuntuacionText.setTypeface(c.getAppValors().getTipoMyriad());
		       miPuntuacionText.setText(""+0);
		       rivalPuntuacionText=(TextView)c.findViewById(R.id.valuerivalpuntuacio);
		       rivalPuntuacionText.setTypeface(c.getAppValors().getTipoMyriad());
		       rivalPuntuacionText.setText(""+0);
		       return view;
	  }
	  @Override         
		 public void onResume() {
		  if (!isVisible) initAnimationsFragment(false);

			 super.onResume();
		}
		
	  
	  public void initAnimationsFragment(final boolean close)
	  {
		  ObjectAnimator translationYHeather=null;
		  if (!close) translationYHeather = ObjectAnimator.ofFloat((FrameLayout) c.findViewById(R.id.fragment_barra_dalt), "translationY", -200,0f);
		  else translationYHeather = ObjectAnimator.ofFloat((FrameLayout) c.findViewById(R.id.fragment_barra_dalt), "translationY", -0,-200f);
		  translationYHeather.setDuration(1000);
		  translationYHeather.setInterpolator(new DecelerateInterpolator());
		  ObjectAnimator translationYFooter=null;
		  if (!close) translationYFooter = ObjectAnimator.ofFloat((RelativeLayout) c.findViewById(R.id.relbarrabaix), "translationY", 300,0f);
		  else translationYFooter = ObjectAnimator.ofFloat((RelativeLayout) c.findViewById(R.id.relbarrabaix), "translationY", 0,300f);
		  translationYFooter.setDuration(1000);
		  translationYFooter.setInterpolator(new DecelerateInterpolator());
		  AnimatorSet translate1= new AnimatorSet();
		  translate1.play(translationYHeather).with(translationYFooter);
		  translate1.addListener(new AnimatorListenerAdapter() {	
			  @Override
              public void onAnimationEnd(Animator animation) {
				  if (close) 
				  {
					 	 ((FrameLayout) c.findViewById(R.id.fragment_barra_dalt)).setVisibility(View.GONE);
			        	 ((RelativeLayout) c.findViewById(R.id.relbarrabaix)).setVisibility(View.GONE);
			        	 isVisible=false;
				  }else isVisible=true;
				  /*else
				  {
					  c.getFragmentTablero().initMyCards();
				  }*/
				  
              }
	         @Override
	         public void onAnimationStart(Animator animation) {
	        	 ((FrameLayout) c.findViewById(R.id.fragment_barra_dalt)).setVisibility(View.VISIBLE);
	        	 ((RelativeLayout) c.findViewById(R.id.relbarrabaix)).setVisibility(View.VISIBLE);
	         }
	        
	       });
		  translate1.start();
	  }
	  class MyTimerTask extends TimerTask {
		  boolean bigText=false;
		  boolean firstTime=true;
		  boolean inAnimation=false;
		  boolean outAnimation=false;
		  public void run() {
			  if (progress>0)
				{		

				
					progress--;
					final int prog=progress;
					if (progress%100==0)
					{
						  Log.v("KCAnim","progress="+progress);
						c.runOnUiThread(new Runnable() {
	                         @Override
	                         public void run() {
	                        	 timeIndicator.setText(" "+prog/100+" ");
	                         }
	                  });
					}
					if (progress==3000)
					{
						c.runOnUiThread(new Runnable() {
	                         @Override
	                         public void run() {
	                        	 	 timeIndicator.setTextColor(Color.argb(255, 255, 156, 0));
	                        		 mSeekArc.setProgressColorOrange();	                        	 
	                         }
	                  });
					}
					else if (progress<=1000&&progress%20==0)
					{
						c.runOnUiThread(new Runnable() {
	                         @Override
	                         public void run() {
	                        	 if (firstTime)
	                        	 {
	                        		 timeIndicator.setTextColor(Color.argb(255, 185, 1, 27));
	                        		 mSeekArc.setProgressColorRed();
	                        		 firstTime=false;
	                        	 }
	                        	 if (progress==0)
	                        	 {
	                        		 if (!outAnimation)
	                        		 {
	                        			 outAnimation=true;
	                        		 myTimer.cancel();
	                        		  c.getFragmentTablero().finishCuentaAtras();
	                        		 Log.v("KCAnim","Clear animation progress 0");
	                        		 finishCuentaAtras=true;
	                        		 stopCuentaAtras();
	                        		 }
	                        		
	                        	 }
	                        	 else 
	                        	 {
	                        		
	                        		 startAnimationScaleTime();
	                        	 }
	                         }
	                  });
					}
					 c.runOnUiThread(new Runnable() {
                         @Override
                         public void run() {
                        	 mSeekArc.setProgress(progress);
                         }
                  });
				}else
				{	
					 myTimer.cancel();
					 Log.v("KCAnim","progress="+progress);
					c.runOnUiThread(new Runnable() {
                         @Override
                         public void run() {
                        	 if (!outAnimation)
                    		 {
                    			 outAnimation=true;
                    		 myTimer.cancel();
                    		  c.getFragmentTablero().finishCuentaAtras();
                    		 Log.v("KCAnim","Clear animation progress 0");
                    		 finishCuentaAtras=true;
                    		 stopCuentaAtras();
                    		 }
					
                         }
	                  });
					
				}
			
		  }
		
			
		 
		  private void startAnimationScaleTime()
		  {
			  //Log.v("Progress","startAnimationScaleTime() inAnimation= "+inAnimation);
			  //Log.v("Progress","startAnimationScaleTime() bigText= "+bigText);
			  if (!inAnimation)
			  {
				  inAnimation=true;
				  ObjectAnimator scaleX= ObjectAnimator.ofFloat(timeIndicator, "scaleX", 1f,2f,1f);
				  ObjectAnimator scaleY= ObjectAnimator.ofFloat(timeIndicator, "scaleY", 1f,2f,1f);
				  if (soundEnabled) heatherSounds.playSound(1);
				  /*if (bigText)
				  {
					  scaleX = ObjectAnimator.ofFloat(timeIndicator, "scaleX", 1f,2f,1f);
						scaleY = ObjectAnimator.ofFloat(timeIndicator, "scaleY", 1f,2f,1f);
				  }else
				  {
					  heatherSounds.playSound(1);
				    scaleX = ObjectAnimator.ofFloat(timeIndicator, "scaleX", 1f,2f);
					scaleY = ObjectAnimator.ofFloat(timeIndicator, "scaleY", 1f,2f);
				  }*/
					 scaleX.setDuration(200);
					 scaleX.setInterpolator(new AccelerateInterpolator());
					 scaleY.setDuration(200);
					 scaleY.setInterpolator(new AccelerateInterpolator());
					 AnimatorSet scale= new AnimatorSet();
					 scale.play(scaleX).with(scaleY);
					
					 scale.addListener(new AnimatorListenerAdapter() {
							
				       @Override
				       public void onAnimationEnd(Animator animation) {
				    	   if (bigText) bigText=false;
				    	   else bigText=true;							
				    	   inAnimation=false;
				       }
				       @Override
				       public void onAnimationStart(Animator animation) {
				       }
				      
				     });
					 scale.start();
			  }
		  }
		
	  
	  
	}
	  public void showMessage(String message) {
		  textInfo.setText(message); 
			
		}
	  @Override         	
		 public void onDestroyView() {
		  Log.v("finish","onDestroyView heather ");
		  stopRunnables();
		 
			super.onDestroyView();
	  }
	 public void startCrono(boolean firstPlayer)
	 {
		 if (firstPlayer)
		 {
			 mSeekArc.setMax(60*100);
			 mSeekArc.setProgress(60*100);
			 timeIndicator.setText(" "+60+" ");
			 progress=60*100;
		 }else
		 {
			 mSeekArc.setMax(tiempoTurno*100);
			 mSeekArc.setProgress(tiempoTurno*100);
			 timeIndicator.setText(" "+tiempoTurno+" ");
			 progress=tiempoTurno*100;
		 }
		 finishCuentaAtras=false;
		
		 mSeekArc.setProgressColorNormal();
		 timeIndicator.setTextColor(Color.argb(255, 0, 197, 0));
		
		 try
		 {
		 if (myTimer!=null)
			 myTimer.cancel();
		 }catch (Exception e)
		 {
			 
		 }
		 myTimer= new Timer();
		// mHandler.postDelayed(runArc, 10);
		 try
		 {
		 if (myTask!=null) myTask.cancel();
		 }catch (Exception e)
		 {
			 
		 }
		 myTask = new MyTimerTask();
		 myTimer.schedule(myTask, 0, 10);        
	 }
	 
	 public int getTurnActual()
	 {
		 
		 return Integer.parseInt(turnIndicator.getText().toString());
	 }
	 
	 public void setTurnIndicator(int numTurn)
	 {
		 if (numTurn==0)
		 {
			 ObjectAnimator scaleX= ObjectAnimator.ofFloat(turnIndicator, "scaleX", 1f,1.4f);
			  ObjectAnimator scaleY= ObjectAnimator.ofFloat(turnIndicator, "scaleY", 1f,1.4f);
			  
				 scaleX.setDuration(300);
				 scaleX.setInterpolator(new AccelerateInterpolator());
				 scaleY.setDuration(300);
				 scaleY.setInterpolator(new AccelerateInterpolator());
				 AnimatorSet scale= new AnimatorSet();
				 scale.play(scaleX).with(scaleY);
				 scale.start();
		 }else if (numTurn==10)
		 {
			 ObjectAnimator scaleX= ObjectAnimator.ofFloat(turnIndicator, "scaleX", 1.4f,1f);
			  ObjectAnimator scaleY= ObjectAnimator.ofFloat(turnIndicator, "scaleY", 1.4f,1f);
			  
				 scaleX.setDuration(300);
				 scaleX.setInterpolator(new AccelerateInterpolator());
				 scaleY.setDuration(300);
				 scaleY.setInterpolator(new AccelerateInterpolator());
				 AnimatorSet scale= new AnimatorSet();
				 scale.play(scaleX).with(scaleY);
				 scale.start();
		 }
		 
		 
		 turnIndicator.setText(""+numTurn);
	 }
	 public void finishRepartirCartes() {
		 //c.getFragmentTablero().initTablero();
		 setTurnIndicator(1);
		
		  Log.v("Partida","finishRepartirCartes");
		  if (c.getFragmentTablero().isCreator())
		  {
			  Log.v("Partida","1");
			  c.getFragmentHeather().startMissatgeAnimatTurn(c.getString(R.string.kronoscards_game_tuturno));
			  c.getFragmentRivalCards().reloadCartes(c.getFragmentTablero().getiPartida().getListCardsByOtherPlayer());
			  //((ProgressBar)view.findViewById(R.id.progressTurn)).setVisibility(View.GONE);
			  textInfo.setText(getString(R.string.kronoscards_game_tuturno));
			  Log.v("Partida","2");
			  startCrono(true);
				c.getFragmentTablero().startTurn();	
				misCartas.setVisibility(View.VISIBLE);
				 ((ImageView)c.findViewById(R.id.btn_mycards)).setVisibility(View.VISIBLE);
				 c.getFragmentMyCards().activateAll();
				 Log.v("Partida","3");
		  }else
		  {
			  Log.v("Partida","4");
			 // ((ProgressBar)view.findViewById(R.id.progressTurn)).setVisibility(View.VISIBLE);
			  textInfo.setText(getString(R.string.kronoscards_game_esperetuturno));
			  c.getFragmentMyCards().desActivateCartes();
			  //((TextView)view.findViewById(R.id.textTurn)).setText(getString(R.string.kronoscards_game_esperetuturno));				 
			  Log.v("Partida","5");
		  }
	 }
	 public void switchTurnView(boolean isMyTurn)
	 {
		  Log.v("Partida","switchTurnView");
		 if (isMyTurn)
		  { 
			 if (c.getFragmentTablero().isMathBall())
			 {
			 c.getFragmentHeather().startMissatgeAnimatTurn(c.getString(R.string.kronoscards_game_tuturno_matchball));
			 }else
			 {
				 c.getFragmentHeather().startMissatgeAnimatTurn(c.getString(R.string.kronoscards_game_tuturno));
			 }
			 if (soundEnabled)
			 {
			 heatherSounds.playSound(1);
			 Handler handler = new Handler(); 
		 	    handler.postDelayed(new Runnable() { 
		 	         public void run() {
		 	        	 heatherSounds.playSound(1);
				 	      }
			 	       }, 300);
			 }
			 startCrono(false);
				c.getFragmentTablero().startTurn();
			 // ((ProgressBar)view.findViewById(R.id.progressTurn)).setVisibility(View.GONE);
			  //((TextView)view.findViewById(R.id.textTurn)).setText(getString(R.string.kronoscards_game_tuturno));
			  textInfo.setText(getString(R.string.kronoscards_game_tuturno));
			  misCartas.setVisibility(View.VISIBLE);
				 ((ImageView)c.findViewById(R.id.btn_mycards)).setVisibility(View.VISIBLE);
				 c.getFragmentMyCards().activateAll();
			
		  }else
		  {
			  textInfo.setText(getString(R.string.kronoscards_game_esperetuturno));
			  c.getFragmentMyCards().desActivateCartes();
			//  ((ProgressBar)view.findViewById(R.id.progressTurn)).setVisibility(View.VISIBLE);
			 // ((TextView)view.findViewById(R.id.textTurn)).setText(getString(R.string.kronoscards_game_esperetuturno));				 
		
		  }
	 }
	public void addCardToGame(Bitmap bm) {
	minicard.setImageBitmap(bm);
	relMiniCard.setVisibility(View.VISIBLE);
	misCartas.setVisibility(View.INVISIBLE);
	}
	public void resetMiniCard() {
		minicard.setImageBitmap(null);
		relMiniCard.setVisibility(View.GONE);
		misCartas.setVisibility(View.VISIBLE);
		 ((ImageView)c.findViewById(R.id.btn_mycards)).setVisibility(View.VISIBLE);
	}
	private void stopRunnables()
	{
		   Log.v("KCAnim","stopRunnables");
		 try
		  {
			 if (myTimer!=null)	 myTimer.cancel();
		  }catch (Exception e)
		  {
			  
		  }
		 try
		 {
		 if (myTask!=null) myTask.cancel();
		 }catch (Exception e)
		 {
			 
		 }
	}
	public void stopCuentaAtras() {
		stopRunnables();
		
		 Handler handler2 = new Handler(); 
		    handler2.postDelayed(new Runnable() { 
		         public void run() {
		        	 initCuentaAtras();
		         } 
		    }, 500);
		
	}
	public void initCuentaAtras()
	{
		finishCuentaAtras=false;
		 progress=tiempoTurno*100;
		 mSeekArc.setProgress(tiempoTurno*100);
		 mSeekArc.setProgressColorNormal();
		 timeIndicator.setTextColor(Color.argb(255, 0, 197, 0));
		 timeIndicator.setText(" "+tiempoTurno+" ");
	}
	
	public void startMissatgeAnimatTurn(String text)
	{
		 final OutlineTextView missatgeAnimat=new OutlineTextView(c);
		 missatgeAnimat.setTypeface(c.getAppValors().getTipoPacifico());
		 missatgeAnimat.setTextColor(Color.argb(255, 0, 197, 0));
		 if (c.getFragmentTablero().isMathBall())
			 missatgeAnimat.setTextSize(40);
		 else
			 missatgeAnimat.setTextSize(60);
		 //missatgeAnimat.setBorderColor(Color.argb(255,102, 51, 0));
		 missatgeAnimat.setBorderColor(Color.WHITE);
		 missatgeAnimat.setBorderSize(20);
			missatgeAnimat.setText(text);
			missatgeAnimat.setVisibility(View.INVISIBLE);
			missatgeAnimat.setLayoutParams(new RelativeLayout.LayoutParams(
					RelativeLayout.LayoutParams.MATCH_PARENT,
					RelativeLayout.LayoutParams.WRAP_CONTENT));
		 Log.v("Partida","startMissatgeAnimat");
		 RelativeLayout.LayoutParams params=(RelativeLayout.LayoutParams) missatgeAnimat.getLayoutParams();
		 params.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		 missatgeAnimat.setLayoutParams(params);
		 final RelativeLayout relTotal=(RelativeLayout)c.findViewById(R.id.reltotal);
		 relTotal.addView(missatgeAnimat);
		
			 ObjectAnimator translationX= ObjectAnimator.ofFloat(missatgeAnimat, "translationX", -1000,0,0,1000);
			 translationX.setDuration(2000);
			 translationX.setInterpolator(new LinearInterpolator());
			 final AnimatorSet translation= new AnimatorSet();
			 translation.play(translationX);
			 translation.addListener(new AnimatorListenerAdapter() {					    				
		         @Override
		         public void onAnimationEnd(Animator animation) {
		        	 missatgeAnimat.setVisibility(View.INVISIBLE);
		        	 relTotal.removeView(missatgeAnimat);
		        	 /*ObjectAnimator translationX= ObjectAnimator.ofFloat(missatgeAnimat, "translationX", 1000,0);
					 translationX.setDuration(100);
					 translationX.setInterpolator(new LinearInterpolator());
					 final AnimatorSet translation= new AnimatorSet();
					 translation.play(translationX);
					 translation.start();
		        	 Log.v("Partida","clearAnimation");
	   	        	// missatgeAnimat.clearAnimation();*/	
	   	        
		         }
		         @Override
		         public void onAnimationStart(Animator animation) {	
		        	 Log.v("Partida","onAnimationStart");
		        	 missatgeAnimat.setVisibility(View.VISIBLE);
		      }					    	        
		       });
			 translation.start();
			
	}
	public void startMissatgeEnterDesempate()
	{
		 final OutlineTextView missatgeAnimat=new OutlineTextView(c);
		 missatgeAnimat.setTypeface(c.getAppValors().getTipoPacifico());
		 missatgeAnimat.setTextColor(Color.argb(255, 0, 197, 0));
		 if (c.getFragmentTablero().isMathBall())
			 missatgeAnimat.setTextSize(40);
		 else
			 missatgeAnimat.setTextSize(60);
		 //missatgeAnimat.setBorderColor(Color.argb(255,102, 51, 0));
		 missatgeAnimat.setBorderColor(Color.WHITE);
		 missatgeAnimat.setBorderSize(20);
			missatgeAnimat.setText(c.getString(R.string.kronoscards_game_tuturno_desempate));
			missatgeAnimat.setVisibility(View.INVISIBLE);
			missatgeAnimat.setLayoutParams(new RelativeLayout.LayoutParams(
					RelativeLayout.LayoutParams.MATCH_PARENT,
					RelativeLayout.LayoutParams.WRAP_CONTENT));
		 Log.v("Partida","startMissatgeAnimat");
		 RelativeLayout.LayoutParams params=(RelativeLayout.LayoutParams) missatgeAnimat.getLayoutParams();
		 params.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		 missatgeAnimat.setLayoutParams(params);
		 final RelativeLayout relTotal=(RelativeLayout)c.findViewById(R.id.reltotal);
		 relTotal.addView(missatgeAnimat);
		
			 ObjectAnimator translationX= ObjectAnimator.ofFloat(missatgeAnimat, "translationY", -1000,0,0,1000);
			 translationX.setDuration(2000);
			 translationX.setInterpolator(new LinearInterpolator());
			 final AnimatorSet translation= new AnimatorSet();
			 translation.play(translationX);
			 translation.addListener(new AnimatorListenerAdapter() {					    				
		         @Override
		         public void onAnimationEnd(Animator animation) {
		        	 missatgeAnimat.setVisibility(View.INVISIBLE);
		        	 relTotal.removeView(missatgeAnimat);
		        	 /*ObjectAnimator translationX= ObjectAnimator.ofFloat(missatgeAnimat, "translationX", 1000,0);
					 translationX.setDuration(100);
					 translationX.setInterpolator(new LinearInterpolator());
					 final AnimatorSet translation= new AnimatorSet();
					 translation.play(translationX);
					 translation.start();
		        	 Log.v("Partida","clearAnimation");
	   	        	// missatgeAnimat.clearAnimation();*/	
	   	        
		         }
		         @Override
		         public void onAnimationStart(Animator animation) {	
		        	 Log.v("Partida","onAnimationStart");
		        	 missatgeAnimat.setVisibility(View.VISIBLE);
		      }					    	        
		       });
			 translation.start();
			
	}
	
	public void startMissatgeAnimat(String text,final boolean winner,final boolean finishGame)
	 {
		 final OutlineTextView missatgeAnimat=new OutlineTextView(c);
		 missatgeAnimat.setTypeface(c.getAppValors().getTipoPacifico());
		 if (winner)
		 missatgeAnimat.setTextColor(Color.argb(255, 0, 197, 0));
		 else
			 missatgeAnimat.setTextColor(Color.argb(255, 185, 1, 27));
		 missatgeAnimat.setTextSize(60);
		 //missatgeAnimat.setBorderColor(Color.argb(255,102, 51, 0));
		 missatgeAnimat.setBorderColor(Color.WHITE);
		 missatgeAnimat.setBorderSize(20);
		 //missatgeAnimat.setShadowLayer(8.0f, 0, 2, Color.GRAY);
			missatgeAnimat.setText(text);
			missatgeAnimat.setVisibility(View.INVISIBLE);
			missatgeAnimat.setLayoutParams(new RelativeLayout.LayoutParams(
					RelativeLayout.LayoutParams.MATCH_PARENT,
					RelativeLayout.LayoutParams.WRAP_CONTENT));
		 Log.v("Partida","startMissatgeAnimat");
		 RelativeLayout.LayoutParams params=(RelativeLayout.LayoutParams) missatgeAnimat.getLayoutParams();
		 params.addRule(RelativeLayout.CENTER_IN_PARENT, RelativeLayout.TRUE);
		 missatgeAnimat.setLayoutParams(params);
		 final RelativeLayout relTotal=(RelativeLayout)c.findViewById(R.id.reltotal);
		 relTotal.addView(missatgeAnimat);
			
			 Log.v("Partida","INVISIBLE");
		 ObjectAnimator scaleX = ObjectAnimator.ofFloat(missatgeAnimat, "scaleX", 0f,1.5f);
   	 ObjectAnimator scaleY = ObjectAnimator.ofFloat(missatgeAnimat, "scaleY", 0f,1.5f);
   	 scaleX.setDuration(1200);
   	 scaleX.setInterpolator(new AccelerateInterpolator());
   	 scaleY.setDuration(1200);
   	 scaleY.setInterpolator(new AccelerateInterpolator());
     	 ObjectAnimator scaleX2 = ObjectAnimator.ofFloat(missatgeAnimat, "scaleX", 1.5f,1f);
   	 ObjectAnimator scaleY2 = ObjectAnimator.ofFloat(missatgeAnimat, "scaleY", 1.5f,1f);
   	 scaleX2.setStartDelay(1200);
   	 scaleX2.setDuration(2000);
   	 scaleX2.setInterpolator(new DecelerateInterpolator());
   	 scaleY2.setStartDelay(1200);
   	 scaleY2.setDuration(2000);
   	 scaleY2.setInterpolator(new DecelerateInterpolator());
   	 ObjectAnimator alphaAnim2 = ObjectAnimator.ofFloat(missatgeAnimat, "alpha", 1f,0f);
      	alphaAnim2.setDuration(2000);
      	alphaAnim2.setStartDelay(1200);

		 final AnimatorSet scale= new AnimatorSet();
		 scale.play(scaleX).with(scaleY).with(scaleX2).with(scaleY2).with(alphaAnim2);					    		
		 scale.addListener(new AnimatorListenerAdapter() {					    				
	         @Override
	         public void onAnimationEnd(Animator animation) {
	        	 missatgeAnimat.setVisibility(View.INVISIBLE);
	        	 relTotal.removeView(missatgeAnimat);
	        	if (finishGame) c.getFragmentTablero().finishMissatgeAnimat(winner);
	         }
	         @Override
	         public void onAnimationStart(Animator animation) {	
	        	 Log.v("Partida","onAnimationStart");
	        	 missatgeAnimat.setVisibility(View.VISIBLE);
	      }					    	        
	       });
		 scale.start();
	 }
	public int getTimeActual() {
		return (progress/100);
	}
	public void uploadPuntuacioMeva(int puntuacio)
	{
		miPuntuacion=miPuntuacion+puntuacio;
		   miPuntuacionText.setText(""+miPuntuacion);
	   
	}
	public void uploadPuntuacioRival(int puntuacio)
	{
		rivalPuntuacion=puntuacio;
		rivalPuntuacionText.setText(""+rivalPuntuacion);
	}
	public int getMiPuntuacio() {
		return miPuntuacion;
	}
	public int getRivalPuntuacio()
	{
		return rivalPuntuacion;
	}
	
	/* public void startMissatgeAnimat(String text,final boolean winner)
	 {
		 Log.v("Partida","startMissatgeAnimat");
		 missatgeAnimat=(OutlineTextView)c.findViewById(R.id.missatgesAnimats);
			missatgeAnimat.setTypeface(c.getAppValors().getTipoPacifico());
			missatgeAnimat.setTextColor(Color.argb(255, 0, 197, 0));
			missatgeAnimat.setText(text);
			missatgeAnimat.setVisibility(View.INVISIBLE);
			 Log.v("Partida","INVISIBLE");
		 ObjectAnimator scaleX = ObjectAnimator.ofFloat(missatgeAnimat, "scaleX", 0f,1.5f);
    	 ObjectAnimator scaleY = ObjectAnimator.ofFloat(missatgeAnimat, "scaleY", 0f,1.5f);
    	 scaleX.setDuration(1200);
    	 scaleX.setInterpolator(new AccelerateInterpolator());
    	 scaleY.setDuration(1200);
    	 scaleY.setInterpolator(new AccelerateInterpolator());
      	 ObjectAnimator scaleX2 = ObjectAnimator.ofFloat(missatgeAnimat, "scaleX", 1.5f,1f);
    	 ObjectAnimator scaleY2 = ObjectAnimator.ofFloat(missatgeAnimat, "scaleY", 1.5f,1f);
    	 scaleX2.setStartDelay(1200);
    	 scaleX2.setDuration(2000);
    	 scaleX2.setInterpolator(new DecelerateInterpolator());
    	 scaleY2.setStartDelay(1200);
    	 scaleY2.setDuration(2000);
    	 scaleY2.setInterpolator(new DecelerateInterpolator());
    	 ObjectAnimator alphaAnim2 = ObjectAnimator.ofFloat(missatgeAnimat, "alpha", 1f,0f);
       	alphaAnim2.setDuration(2000);
       	alphaAnim2.setStartDelay(1200);

		 final AnimatorSet scale= new AnimatorSet();
		 scale.play(scaleX).with(scaleY).with(scaleX2).with(scaleY2).with(alphaAnim2);					    		
		 scale.addListener(new AnimatorListenerAdapter() {					    				
	         @Override
	         public void onAnimationEnd(Animator animation) {
	        	 missatgeAnimat.setVisibility(View.INVISIBLE);
	        	 ObjectAnimator alphaAnim2 = ObjectAnimator.ofFloat(missatgeAnimat, "alpha", 0f,1f);
	            	alphaAnim2.setDuration(100);
	            	 final AnimatorSet translation= new AnimatorSet();
					 translation.play(alphaAnim2);
					 translation.start();
	        	 Log.v("Partida","clearAnimation");
   	        	// missatgeAnimat.clearAnimation();	
   	        	// missatgeAnimat.getAnimation().reset();	
   	        	 Log.v("Partida","reset");
   	        	 c.getFragmentTablero().finishMissatgeAnimat(winner);
	        	
	         }
	         @Override
	         public void onAnimationStart(Animator animation) {	
	        	 Log.v("Partida","onAnimationStart");
	        	 missatgeAnimat.setVisibility(View.VISIBLE);
	      }					    	        
	       });
		 scale.start();
	 }*/
}
