package com.kronoscards.fragments;

import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;


public class Fragment_MainScreen  extends Fragment {
	
	 MainActivity p;
	 View view;
	
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_mainscreen, container, false);
		       Log.v("Timeline", "Fragment_Main Screen create");
		       p=(MainActivity) getActivity();
		       p.setNumFragment(1);
		       Button show_invitacions=(Button)view.findViewById(R.id.button_show_invitations);
		       show_invitacions.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					if (p.isRoomLeaved())
					{
						p.showInvitations();
					}else p.callAlert(p.getString(R.string.kronoscards_alerta_esperandodesconexion));
				}
		    	   
		       });
		       Button invite_friend=(Button)view.findViewById(R.id.button_invite_players);
		       invite_friend.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					if (p.isRoomLeaved())
					{
					p.inviteFriends();
					}else p.callAlert(p.getString(R.string.kronoscards_alerta_esperandodesconexion));
				}
		    	   
		       });
		       Button quickgame=(Button)view.findViewById(R.id.button_quickgame);
		       quickgame.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					if (p.isRoomLeaved())
					{
					p.startQuickGame();
				}else p.callAlert(p.getString(R.string.kronoscards_alerta_esperandodesconexion));
				}
		    	   
		       });
		       Button btn_opciones=(Button)view.findViewById(R.id.button_opciones);
		       btn_opciones.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					p.showFragmentOpciones();
					
				}
		    	   
		       });
		       Button btn_instrucciones=(Button)view.findViewById(R.id.button_instruciones);
		       btn_instrucciones.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					p.showFragmentInstrucciones();
					
				}
		    	   
		       });
		       p.stopDialog();
		       return view;
	  }

}
