package com.kronoscards.fragments;

import java.util.ArrayList;
import java.util.List;

import com.kronoscards.adaptscreen.AutoResizeTextView;
import com.kronoscards.adaptscreen.MyHorizontalScrollView;
import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.adaptscreen.RoundedImageView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.kronoscards.pack.Carta;
import com.kronoscards.pack.UtilitatsTablero;
import com.nineoldandroids.animation.Animator;
import com.nineoldandroids.animation.AnimatorListenerAdapter;
import com.nineoldandroids.animation.AnimatorSet;
import com.nineoldandroids.animation.ObjectAnimator;

import android.annotation.SuppressLint;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver;
import android.view.View.OnClickListener;
import android.view.ViewTreeObserver.OnGlobalLayoutListener;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.LinearInterpolator;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class Fragment_MyCards  extends Fragment {
	
	 MainActivity c;
	 View view;
	 ImageView btn_openMyCards;
	 LinearLayout layoutInflate;
	 boolean isOpened=true;
	 boolean inAnimation=false;
	 boolean initValuesTranslation=false;
	 float yTranslate=0;
	 int numOfCards=10;
	 int numJugades=0;
	 int maxNumOfCards=10;
	 MyHorizontalScrollView scroll;
	 RelativeLayout relGeneral;
	 private boolean init=false;
	 private boolean isPlaying=false;
	 
	 RelativeLayout cartaViewToAdd;
	 Carta cartaToAdd;
	 Bitmap bmToAdd;
	 
	 List<Carta> listMyCartas=new ArrayList<Carta>();
	 List<Integer> listMyCardsIds=new ArrayList<Integer>();
	 int maxElementsInScrollWindow=3;
	 int nextElement=0;
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_mycards, container, false);
		       c=(MainActivity) getActivity();
		       layoutInflate=(LinearLayout)view.findViewById(R.id.linearinflate);
		       relGeneral=(RelativeLayout)view.findViewById(R.id.rel_general_mycards);
		       scroll=(MyHorizontalScrollView)view.findViewById(R.id.scrollmycards);
		       final ViewTreeObserver vto = scroll.getViewTreeObserver();
				vto.addOnGlobalLayoutListener(new OnGlobalLayoutListener() {
					@SuppressLint("NewApi")
					@SuppressWarnings("deprecation")
					@Override
				    public void onGlobalLayout() {						
				    	if (!initValuesTranslation)
				    	{
				    		initValuesTranslation();			    		
				    		if(Build.VERSION.SDK_INT < Build.VERSION_CODES.JELLY_BEAN) {
				    			scroll.getViewTreeObserver().removeGlobalOnLayoutListener(this);
				    		} else {
				    			scroll.getViewTreeObserver().removeOnGlobalLayoutListener(this);
				    		}		    		
				    	}
				    }
				});
		       btn_openMyCards=(ImageView)c.findViewById(R.id.btn_mycards);
		       btn_openMyCards.setOnClickListener(new OnClickListener(){
				@Override
				public void onClick(View v) {
					if (isOpened&&!inAnimation)
					{
						close(false,true);
					}else if (!isOpened&&!inAnimation)
					{
						open(false);
					}
					}		    	   
		       });
		       //close(false);
		       return view;
	  }
	  public Integer getIdNextCard()
	  {
		  if (listMyCartas.size()<nextElement)
			  
			  return Integer.valueOf(listMyCartas.get(nextElement).getId());
		  else
		  {
			  //finishCards
			  return -1;
		  }
	  }
	  public List<Integer> getActualListCartes()
	  {
		  return listMyCardsIds;
	  }
	  public void initFragment(List<Integer> listOfCards)
		{
		  Log.v("MyCards","initFragment"+listOfCards.toString());
			if (!init)
			{
				 Log.v("MyCards","!init");
				for (Integer id:listOfCards)
				{
					listMyCartas.add(c.getDatabase().getCartaById(""+id));	
				}
				numOfCards=c.getFragmentTablero().getoPartida().getNumCardsByPlayer();
				c.getUtils().disableEnableControls(false, relGeneral);
				scroll.setEnableScrolling(false);			
			 if (listMyCartas!=null&&listMyCartas.size()>0)
			   	 {
						 init=true;
					 Handler handler = new Handler(); 
						    handler.postDelayed(new Runnable() { 
						         public void run() {
						        	 for (int i=0;i<numOfCards;i++)
							     		{
							     			inflateNewCard(i);
							     		}
						        	
						         } 
						    }, 500);
		
			   	 }
			}
		}
	  private void inflateNewCard(int position)
		{
		  Log.v("MyCards","inflateNewCard");
			 if (listMyCardsIds.size()<numOfCards)
			 {	
				  Log.v("MyCards","listMyCardsIds.size()<numOfCards");
					final Carta carta=listMyCartas.get(position);
					listMyCardsIds.add(carta.getId());
					nextElement++;
					 final RelativeLayout card=UtilitatsTablero.getRelForCard(carta, c, false);
					 card.setVisibility(View.INVISIBLE);
					 card.setOnClickListener(new OnClickListener(){

							@Override
							public void onClick(View v) {
								gestioAddCartToTablero(card,carta);
							}							
						});
					 card.setEnabled(false);					 
					 layoutInflate.addView(card,listMyCardsIds.size()-1);
					 Handler handler = new Handler(); 
					    handler.postDelayed(new Runnable() { 
					         public void run() {
					        	 ObjectAnimator scaleX = ObjectAnimator.ofFloat(card, "scaleX", 0f,1f);
					        	 ObjectAnimator scaleY = ObjectAnimator.ofFloat(card, "scaleY", 0f,1f);
					        	 scaleX.setDuration(500);
					        	 scaleX.setInterpolator(new DecelerateInterpolator());
					        	 scaleY.setDuration(500);
					        	 scaleY.setInterpolator(new DecelerateInterpolator());
					    		 AnimatorSet scale= new AnimatorSet();
					    		 scale.play(scaleX).with(scaleY);					    		
					    		 scale.addListener(new AnimatorListenerAdapter() {					    				
					    	         @Override
					    	         public void onAnimationEnd(Animator animation) {
					    	        	 /*ObjectAnimator animator=ObjectAnimator.ofInt(scroll, "scrollX",((int)scroll.getScrollX()+300)).setDuration(500);
						 					animator.start();*/
					    	        	 int position=getPositionFromList(carta);
					    	        	 if (position==listMyCardsIds.size()-1)
					    	        	 {
					    	        		 scroll.smoothScrollTo(scroll.getScrollX()+200, 0);
					    	        		 c.getFragmentTablero().initTablero();
					    	        		 scroll.setEnableScrolling(true);
					    	        		 //p.getUtilitats().disableEnableControls(true, relGeneral);
					    	        	 }
					    	        	 startShowTitulo(card);		
					    	         }
					    	         @Override
					    	         public void onAnimationStart(Animator animation) {				    	        	 
					    	        	 card.setVisibility(View.VISIBLE);
					    	        	 int position=getPositionFromList(carta);
					    	        	 if (position>maxElementsInScrollWindow)
					    	        	 {
					    	        		 Log.v("Scroll","Carta= "+carta.getTitulo());
					    	        		 Log.v("Scroll","scroll position= "+scroll.getScrollX());
					    	        		 scroll.smoothScrollTo(scroll.getScrollX()+200, 0);
					    	        	 }
					    	      }					    	        
					    	       });
					    		 scale.start();					        	
					         } 
					    }, 500+(listMyCardsIds.size()*500));
			 }
		}
	  private void startShowTitulo(RelativeLayout card)
	  {
	  	 final AutoResizeTextView titulo=(AutoResizeTextView)card.findViewById(R.id.titulo);
	  	 ObjectAnimator translationX = ObjectAnimator.ofFloat(titulo, "translationY", -100f,0);	  	 
	  	 translationX.setDuration(500);
	  	 translationX.setInterpolator(new LinearInterpolator());	  	
	  	 AnimatorSet translate1= new AnimatorSet();
	  	 translate1.play(translationX);	  	
	  	 translate1.addListener(new AnimatorListenerAdapter() {	  			
	          @Override
	          public void onAnimationEnd(Animator animation) {
	          }
	          @Override
	          public void onAnimationStart(Animator animation) {
	         	 titulo.setVisibility(View.VISIBLE);
	          }	         
	        });
	  	 translate1.start();
	  }
	  private void hideTitulo()
	  {
	  	 final AutoResizeTextView titulo=(AutoResizeTextView)cartaViewToAdd.findViewById(R.id.titulo);
	  	 ObjectAnimator translationX = ObjectAnimator.ofFloat(titulo, "translationY", 0f,-100f);	  	 
	  	 translationX.setDuration(500);
	  	 translationX.setInterpolator(new LinearInterpolator());	  	
	  	 AnimatorSet translate1= new AnimatorSet();
	  	 translate1.play(translationX);	  	
	  	 translate1.addListener(new AnimatorListenerAdapter() {	  			
	         @Override
	         public void onAnimationEnd(Animator animation) {
	      	   titulo.setVisibility(View.INVISIBLE);
	      	 RoundedImageView foto=(RoundedImageView)cartaViewToAdd.findViewById(R.id.fotocarta);
	      	 foto.setDrawingCacheEnabled(true);
	      	 foto.buildDrawingCache();
	      	   bmToAdd = foto.getDrawingCache();
	       		startAnimationOutCard();	
	       	 Log.v("Partida","replaceCardaDeScroll nextElement in hide titulo= "+nextElement);
	         }
	         @Override
	         public void onAnimationStart(Animator animation) {	        	 
	         }	        
	       });
	  	 translate1.start();
	  }
	  private void startAnimationOutCard()
	  {
	  	ObjectAnimator scaleX = ObjectAnimator.ofFloat(cartaViewToAdd, "scaleX", 1f,0f);
	  	 ObjectAnimator scaleY = ObjectAnimator.ofFloat(cartaViewToAdd, "scaleY", 1f,0f);
	  	 ObjectAnimator alpha= ObjectAnimator.ofFloat(cartaViewToAdd,"alpha",1f,0f);
	  	 scaleX.setDuration(500);
	  	 scaleX.setInterpolator(new AccelerateInterpolator());
	  	 scaleY.setDuration(500);
	  	 scaleY.setInterpolator(new AccelerateInterpolator());
	  	 alpha.setDuration(500);
	  	 alpha.setInterpolator(new LinearInterpolator());
	  	 AnimatorSet scale= new AnimatorSet();
	  	 scale.play(scaleX).with(scaleY).with(alpha);
	  	
	  	 scale.addListener(new AnimatorListenerAdapter() {
	  			
	          @Override
	          public void onAnimationEnd(Animator animation) { 
	          	if (!isPlaying)
	          	{
	          		isPlaying=true;
	          	numJugades++;
	          	c.getFragmentTablero().addCardToGame(cartaToAdd,bmToAdd);
	          	}
	         	
	          }
	          @Override
	          public void onAnimationStart(Animator animation) {			
	          }
	         
	        });
	  	 scale.start();

	  }
	  private int getPositionFromList(Carta carta)
		{
			for (int i=0;i<listMyCardsIds.size();i++)
			{
				if (listMyCardsIds.get(i)==carta.getId()) return i;
			}
			return 0;
		}
	  public void open(final boolean quickly)
	  {
		  Log.v("MyCards", "open MyCards");		  
		  if (!isOpened&&!inAnimation)
		  {			 
			  Log.v("MyCards","!isOpened&&!inAnimation");
			  disableEnableAll(false);
			  if (!initValuesTranslation) initValuesTranslation();
			  ObjectAnimator translationY = ObjectAnimator.ofFloat((RelativeLayout) c.findViewById(R.id.relmycards), "translationY", yTranslate,0f);
			  if (quickly) translationY.setDuration(0);
				 else	 translationY.setDuration(500);
					 AnimatorSet translate= new AnimatorSet();
					 translate.setInterpolator(new DecelerateInterpolator());
				 translate.play(translationY);
				 translate.addListener(new AnimatorListenerAdapter() {
			         @Override
			         public void onAnimationEnd(Animator animation) {
			        	 Log.v("MyCards","MyCards open onAnimationEnd");
			        	 isOpened=true;
			        	 inAnimation=false;			        	 
			        	 btn_openMyCards.setImageResource(R.drawable.btn_rojo_down);
			        	 disableEnableAll(true);
			        	 if (!c.getFragmentTablero().isMyTurn())
			        	 {
			        		 c.getUtils().disableEnableControls(false, relGeneral);
			        	 }
			        	 TextView tituloMisCartas=(TextView) c.findViewById(R.id.miscardstext);
		        		 tituloMisCartas.setVisibility(View.VISIBLE);
			        	 OutlineTextView rivalCards=(OutlineTextView)c.findViewById(R.id.rivalname);
			        	 rivalCards.setTextColor(Color.argb(255, 185, 1, 27));
			        	 rivalCards.setText(c.getString(R.string.kronoscards_game_miscartaspredef));
			         }
			         @Override
			         public void onAnimationStart(Animator animation) {
			        	 btn_openMyCards.setVisibility(View.VISIBLE);
			        	 inAnimation=true;
			        	 scroll.setVisibility(View.VISIBLE);
			        	 if (!quickly) ((RelativeLayout) c.findViewById(R.id.relmycards)).setVisibility(View.VISIBLE);
			        	 
			         }
			       });
				 translate.start(); 
		  }
	  }
	  public void close(final boolean quickly,final boolean showOpenButon)
	  {
		  Log.v("MyCards","close");
		  if (isOpened&&!inAnimation)
		  {			 
			  Log.v("MyCards","isOpened&&!inAnimation");
			  disableEnableAll(false);
			  if (!initValuesTranslation) initValuesTranslation();
			  RelativeLayout relMyCards=(RelativeLayout) c.findViewById(R.id.relmycards);
			  ObjectAnimator translationY = ObjectAnimator.ofFloat(relMyCards, "translationY", 0f,yTranslate);
			  
				 if (quickly) translationY.setDuration(0);
				 else	 translationY.setDuration(500);
					 AnimatorSet translate= new AnimatorSet();
					 translate.setInterpolator(new AccelerateInterpolator());
					 translate.play(translationY);
					
				 translate.addListener(new AnimatorListenerAdapter() {
			         @Override
			         public void onAnimationEnd(Animator animation) {
			        	 Log.v("MyCards","MyCards close onAnimationEnd");
			        	 isOpened=false;
			        	 inAnimation=false;
			        	 btn_openMyCards.setImageResource(R.drawable.btn_verde_up);
			        	 if (!showOpenButon)
			        	 {
			        		 btn_openMyCards.setVisibility(View.INVISIBLE);
			        		 TextView tituloMisCartas=(TextView) c.findViewById(R.id.miscardstext);
			        		 tituloMisCartas.setVisibility(View.INVISIBLE);
			        	 }
			        	 else 
			        		 {
			        		 btn_openMyCards.setVisibility(View.VISIBLE);
			        		 TextView tituloMisCartas=(TextView) c.findViewById(R.id.miscardstext);
			        		 tituloMisCartas.setVisibility(View.VISIBLE);
			        		 }
			        	 //btn_openMyCards.setVisibility(View.INVISIBLE);
			        	// relGeneral.setVisibility(View.INVISIBLE);
			        	 scroll.setVisibility(View.GONE);
			        	 disableEnableAll(true);
			         }
			         @Override
			         public void onAnimationStart(Animator animation) {
			        	 inAnimation=true;
			        	if (!quickly) ((RelativeLayout) c.findViewById(R.id.relmycards)).setVisibility(View.VISIBLE);
			        	try
			        	{
			        	 OutlineTextView rivalCards=(OutlineTextView)c.findViewById(R.id.rivalname);
			        	 rivalCards.setTextColor(Color.argb(255, 0, 197, 0));
			        	 rivalCards.setText(c.getString(R.string.kronoscards_game_rivalnamepredef));
			        	}catch (Exception e)
			        	{
			        		
			        	}
			       
			         }
			       });
				 translate.start(); 
		  }
	  }
	  private void initValuesTranslation()
	  {
		  Log.v("MyCards","MyCards  initValuesTranslation");
		  ImageView btn_rivalcards=(ImageView)c.findViewById(R.id.btn_rivalcards);
		  yTranslate=c.getAppValors().getScreenHeight()-btn_rivalcards.getBottom();
		  c.getAppValors().setQttTranslate(yTranslate);
			Log.v("MyCards","yTranslate= "+yTranslate);
			
		  initValuesTranslation=true;
		  close(true,true);
		 // c.getFragmentRivalCards().close(true);
	  }
	  
	  
	  private void removeCartaDeScroll()
	  {
		  listMyCardsIds.remove(listMyCardsIds.indexOf(Integer.valueOf(cartaToAdd.getId())));
	  	 layoutInflate.removeView(cartaViewToAdd);
	  	 cartaViewToAdd=null;
	      	cartaToAdd=null;
	      	bmToAdd=null;
	      	c.getUtils().disableEnableControls(true, relGeneral);
	      	scroll.setEnableScrolling(true);
	  }
	  private void replaceCardaDeScroll()
	  {
		  Log.v("Partida","replaceCardaDeScroll nextElement= "+nextElement);
		  Log.v("Partida","Position carta="+listMyCardsIds.indexOf(Integer.valueOf(cartaToAdd.getId())));
		  Log.v("Partida","Position carta not value of="+listMyCardsIds.indexOf(cartaToAdd.getId()));
		  if (numJugades<c.getFragmentTablero().getoPartida().getMaxCards()&&nextElement<listMyCartas.size())
		  {  
			  //final Carta carta=listMyCartas.get(listMyCardsIds.size());
			  final Carta carta=listMyCartas.get(nextElement);
			  nextElement++;
				
				 final RelativeLayout card=UtilitatsTablero.getRelForCard(carta, c, false);
				 card.setOnClickListener(new OnClickListener(){
	
						@Override
						public void onClick(View v) {
							gestioAddCartToTablero(card,carta);
							
						}							
					});
				 card.setEnabled(false);
				 card.setVisibility(View.INVISIBLE);
				 int position=layoutInflate.indexOfChild(cartaViewToAdd);
				 layoutInflate.removeView(cartaViewToAdd);
				 layoutInflate.addView(card,position);
				 
				 listMyCardsIds.remove(listMyCardsIds.indexOf(Integer.valueOf(cartaToAdd.getId())));
				 listMyCardsIds.add(Integer.valueOf(carta.getId()));
				 ObjectAnimator scaleX = ObjectAnimator.ofFloat(card, "scaleX", 0f,1f);
				 ObjectAnimator scaleY = ObjectAnimator.ofFloat(card, "scaleY", 0f,1f);
				 //ObjectAnimator alpha= ObjectAnimator.ofFloat(card,"alpha",0f,1f);
				 scaleX.setDuration(500);
				 scaleX.setInterpolator(new DecelerateInterpolator());
				 scaleY.setDuration(500);
				 scaleY.setInterpolator(new DecelerateInterpolator());
				// alpha.setDuration(500);
				// alpha.setInterpolator(new DecelerateInterpolator());
				 AnimatorSet scale= new AnimatorSet();
				 scale.play(scaleX).with(scaleY);//.with(alpha);
				
				 scale.addListener(new AnimatorListenerAdapter() {
						
			         @Override
			         public void onAnimationEnd(Animator animation) {	    	        	 
			        	 startShowTitulo(card);
			        	 cartaViewToAdd=null;
			         	cartaToAdd=null;
			         	bmToAdd=null;
			         	scroll.setEnableScrolling(true);
			         	c.getFragmentTablero().finishReplaceCard();
			        	 
			        	
			         }
			         @Override
			         public void onAnimationStart(Animator animation) {				    	        	 
			        	 card.setVisibility(View.VISIBLE);
			        	 
			         }
			        
			       });
				 scale.start();		
		  }else
		  {
			  
			  //Gestio final de cartes
			  c.getFragmentTablero().finishCards();
		  }
	  }
	  private void gestioAddCartToTablero(RelativeLayout card,Carta carta)
	  {
		  if (c.getFragmentTablero().isAllStatesOff())
			{
				c.getFragmentTablero().setStateIsAddingCardToGame(true);
				c.getUtils().disableEnableControls(false, relGeneral);
				scroll.setEnableScrolling(false);
				 cartaViewToAdd=card;
				 cartaToAdd=carta;
				 if (c.getFragmentHeather().getTimeActual()<=10)
				 {
					 AutoResizeTextView titulo=(AutoResizeTextView)cartaViewToAdd.findViewById(R.id.titulo);
					 titulo.setVisibility(View.INVISIBLE);
					 RoundedImageView foto=(RoundedImageView)cartaViewToAdd.findViewById(R.id.fotocarta);
			      	 foto.setDrawingCacheEnabled(true);
			      	 foto.buildDrawingCache();
			      	   bmToAdd = foto.getDrawingCache();
					  /*cartaViewToAdd.setDrawingCacheEnabled(true);
			      	   cartaViewToAdd.buildDrawingCache();
			      	   bmToAdd = cartaViewToAdd.getDrawingCache();*/
			      	 cartaViewToAdd.setVisibility(View.INVISIBLE);
			      	 if (!isPlaying)
			          	{
			          		isPlaying=true;
			          	numJugades++;
			          	c.getFragmentTablero().addCardToGame(cartaToAdd,bmToAdd);
			          	}
			         	
				 }
				 else hideTitulo();
			}
	  }
	  private void restartAnimationInCard()
	  {
	  	ObjectAnimator scaleX = ObjectAnimator.ofFloat(cartaViewToAdd, "scaleX", 0f,1f);
	  	 ObjectAnimator scaleY = ObjectAnimator.ofFloat(cartaViewToAdd, "scaleY", 0f,1f);
	  	 ObjectAnimator alpha= ObjectAnimator.ofFloat(cartaViewToAdd,"alpha",0f,1f);
	  	 scaleX.setDuration(500);
	  	 scaleX.setInterpolator(new AccelerateInterpolator());
	  	 scaleY.setDuration(500);
	  	 scaleY.setInterpolator(new AccelerateInterpolator());
	  	 alpha.setDuration(0);
	  	 alpha.setInterpolator(new LinearInterpolator());
	  	 AnimatorSet scale= new AnimatorSet();
	  	 scale.play(scaleX).with(scaleY).with(alpha);
	  	
	  	 scale.addListener(new AnimatorListenerAdapter() {
	  			
	          @Override
	          public void onAnimationEnd(Animator animation) {
	          	final AutoResizeTextView titulo=(AutoResizeTextView)cartaViewToAdd.findViewById(R.id.titulo);
	         	 ObjectAnimator translationX = ObjectAnimator.ofFloat(titulo, "translationY", -100f,0);
	         	 
	         	 translationX.setDuration(500);
	         	 translationX.setInterpolator(new LinearInterpolator());
	         	
	         	 AnimatorSet translate1= new AnimatorSet();
	         	 translate1.play(translationX);
	         	
	         	 translate1.addListener(new AnimatorListenerAdapter() {
	         			
	                 @Override
	                 public void onAnimationEnd(Animator animation) {  
	                	 c.getFragmentTablero().setStateIsAddingCardToGame(false);
	                 	cartaViewToAdd=null;
	                 	cartaToAdd=null;
	                 	bmToAdd=null;
	                 	c.getUtils().disableEnableControls(true, relGeneral);
	                 	scroll.setEnableScrolling(true);
	                 }
	                 @Override
	                 public void onAnimationStart(Animator animation) {
	                	 titulo.setVisibility(View.VISIBLE);
	                 }
	                
	               });
	         	 translate1.start();
	          }
	          @Override
	          public void onAnimationStart(Animator animation) {	
	        		 cartaViewToAdd.setVisibility(View.VISIBLE);
	          }
	         
	        });
	  	 scale.start();

	  }
	  
	  public boolean isFinish()
	  {
	  	if (layoutInflate.getChildCount()==0) return true;
	  	else return false;
	  }
	  public void deleteCarta() {
	  	isPlaying=false;
	  	removeCartaDeScroll();
	  	
	  }
	  public void cancelCarta() {
	  	numJugades--;
	  	isPlaying=false;
	  	restartAnimationInCard();
	  	
	  }
	  public void addCardError() {
	  	isPlaying=false;
	  	desActivateAll();
	  	replaceCardaDeScroll();
	  	
	  }
	  public boolean noInit() {
	  	return init;
	  }
	  
	  
	  public void disableEnableAll(boolean enable) {
			RelativeLayout relGeneral=(RelativeLayout)c.findViewById(R.id.reltotal);
			c.getUtils().disableEnableControls(enable, relGeneral);
			
		}
	  
	  public void desActivateCartes()
	  {
			c.getUtils().disableEnableControls(false, relGeneral);
	  }
	  public void desActivateAll() {
			c.getUtils().disableEnableControls(false, relGeneral);
			scroll.setEnableScrolling(false);	
		}
		public void desActivateScroll() {
			scroll.setEnableScrolling(false);	
		}
		public void activateAll() {
			c.getUtils().disableEnableControls(true, relGeneral);
			scroll.setEnableScrolling(true);	
		}
		public void activateScroll() {
			scroll.setEnableScrolling(true);	
		}
		 public int getNumCartesRestants()
		  {
			  return layoutInflate.getChildCount();
		  }

		public boolean isPerfect() {
			if (numJugades==numOfCards) return true;
			else return false;
		}
		
		public boolean isOpened() {
			return isOpened;
		}
		 @Override         	
		 public void onDestroyView() {
			 relGeneral.setVisibility(View.GONE);
		  Log.v("finish","onDestroyView My Cards ");
		  layoutInflate.removeAllViews();
			super.onDestroyView();
	  }
		public void generateNewCardDesempate() {
			 if (numJugades<c.getFragmentTablero().getoPartida().getMaxCards()&&nextElement<listMyCartas.size())
			  {  
				  //final Carta carta=listMyCartas.get(listMyCardsIds.size());
				  final Carta carta=listMyCartas.get(nextElement);
				  nextElement++;
					
					 final RelativeLayout card=UtilitatsTablero.getRelForCard(carta, c, false);
					 card.setOnClickListener(new OnClickListener(){
		
							@Override
							public void onClick(View v) {
								gestioAddCartToTablero(card,carta);
							}							
						});
					 card.setEnabled(false);
					 card.setVisibility(View.INVISIBLE);
					 layoutInflate.addView(card,0);					 
					 
					 listMyCardsIds.add(Integer.valueOf(carta.getId()));
					 ObjectAnimator scaleX = ObjectAnimator.ofFloat(card, "scaleX", 0f,1f);
					 ObjectAnimator scaleY = ObjectAnimator.ofFloat(card, "scaleY", 0f,1f);
					 //ObjectAnimator alpha= ObjectAnimator.ofFloat(card,"alpha",0f,1f);
					 scaleX.setDuration(500);
					 scaleX.setInterpolator(new DecelerateInterpolator());
					 scaleY.setDuration(500);
					 scaleY.setInterpolator(new DecelerateInterpolator());
					// alpha.setDuration(500);
					// alpha.setInterpolator(new DecelerateInterpolator());
					 AnimatorSet scale= new AnimatorSet();
					 scale.play(scaleX).with(scaleY);//.with(alpha);
					
					 scale.addListener(new AnimatorListenerAdapter() {
							
				         @Override
				         public void onAnimationEnd(Animator animation) {	    	        	 
				        	 startShowTitulo(card);
				        	 Handler handler = new Handler(); 
						 	    handler.postDelayed(new Runnable() { 
						 	         public void run() {
						 	        	scroll.setEnableScrolling(true);
							         	c.getFragmentTablero().finishAddCardDesempate();
								 	      }
							 	       }, 1500);
				         
				        	 
				        	
				         }
				         @Override
				         public void onAnimationStart(Animator animation) {				    	        	 
				        	 card.setVisibility(View.VISIBLE);
				        	 
				         }
				        
				       });
					 scale.start();		
			  }else
			  {
				  
				  //Gestio final de cartes
				  c.getFragmentTablero().finishCards();
			  }
			
		}
}
