package com.kronoscards.fragments;

import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AccelerateInterpolator;
import android.view.animation.DecelerateInterpolator;
import android.view.animation.LinearInterpolator;
import android.widget.ImageView;

import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;
import com.nineoldandroids.animation.Animator;
import com.nineoldandroids.animation.AnimatorListenerAdapter;
import com.nineoldandroids.animation.AnimatorSet;
import com.nineoldandroids.animation.ObjectAnimator;

public class Fragment_Splash extends Fragment {
	
	 MainActivity c;
	 View view;
	 OutlineTextView lletra1,lletra2,lletra3,lletra4,lletra5,lletra6,lletra7,lletra8,lletra9,lletra10,lletra11;
	 int offsetEntrada=500;
	 ImageView fondo;
	 
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_splash, container, false);
		       Log.v("Timeline", "Fragment_Splash create");
		       c=(MainActivity) getActivity();
		       fondo=(ImageView)view.findViewById(R.id.fondo);
		       lletra1=(OutlineTextView)view.findViewById(R.id.lletra1);
		       lletra2=(OutlineTextView)view.findViewById(R.id.lletra2);
		       lletra3=(OutlineTextView)view.findViewById(R.id.lletra3);
		       lletra4=(OutlineTextView)view.findViewById(R.id.lletra4);
		       lletra5=(OutlineTextView)view.findViewById(R.id.lletra5);
		       lletra6=(OutlineTextView)view.findViewById(R.id.lletra6);
		       lletra7=(OutlineTextView)view.findViewById(R.id.lletra7);
		       lletra8=(OutlineTextView)view.findViewById(R.id.lletra8);
		       lletra9=(OutlineTextView)view.findViewById(R.id.lletra9);
		       lletra10=(OutlineTextView)view.findViewById(R.id.lletra10);
		       lletra11=(OutlineTextView)view.findViewById(R.id.lletra11);
		       lletra1.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra2.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra3.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra4.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra5.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra6.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra7.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra8.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra9.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra10.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra11.setTypeface(c.getAppValors().getTipoPacifico());
		       lletra1.setTextColor(Color.argb(255, 0, 197, 0));
		       lletra2.setTextColor(Color.argb(255, 255, 156, 0));
		       lletra3.setTextColor(Color.argb(255, 185, 1, 27));
		       lletra4.setTextColor(Color.argb(255, 0, 197, 0));
		       lletra5.setTextColor(Color.argb(255, 255, 156, 0));
		       lletra6.setTextColor(Color.argb(255, 185, 1, 27));
		       lletra7.setTextColor(Color.argb(255, 0, 197, 0));
		       lletra8.setTextColor(Color.argb(255, 255, 156, 0));
		       lletra9.setTextColor(Color.argb(255, 185, 1, 27));
		       lletra10.setTextColor(Color.argb(255, 0, 197, 0));
		       lletra11.setTextColor(Color.argb(255, 255, 156, 0));
		       
		       return view;
	  }
	  @Override         
		 public void onResume() {
			 
			 Handler handler = new Handler(); 
			    handler.postDelayed(new Runnable() { 
			         public void run() { 	
			        	 startAllAnimations();
			         } 
			    }, 500); 	  
			 super.onResume();
		}
	  private void startAllAnimations()
	  {
		  ObjectAnimator translationY = ObjectAnimator.ofFloat(lletra1, "translationY", -offsetEntrada,50f,0f);
			 translationY.setDuration(400);
			 translationY.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation1 = ObjectAnimator.ofFloat(lletra1, "rotation", 0,360);
			 rotation1.setDuration(400);
			 rotation1.setStartDelay(1000);
			 rotation1.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut1 = ObjectAnimator.ofFloat(lletra1, "translationY", 0f,offsetEntrada);
			 translationOut1.setDuration(400);
			 translationOut1.setStartDelay(2500);
			 translationOut1.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY2 = ObjectAnimator.ofFloat(lletra2, "translationY", -offsetEntrada,50f,0f);
			 translationY2.setDuration(400);
			 translationY2.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation2 = ObjectAnimator.ofFloat(lletra2, "rotation", 0,360);
			 rotation2.setDuration(400);
			 rotation2.setStartDelay(1000);
			 rotation2.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut2 = ObjectAnimator.ofFloat(lletra2, "translationY", 0f,offsetEntrada);
			 translationOut2.setDuration(400);
			 translationOut2.setStartDelay(2500);
			 translationOut2.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY3 = ObjectAnimator.ofFloat(lletra3, "translationY", -offsetEntrada,50f,0f);
			 translationY3.setDuration(400);
			 translationY3.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation3 = ObjectAnimator.ofFloat(lletra3, "rotation", 0,360);
			 rotation3.setDuration(400);
			 rotation3.setStartDelay(1000);
			 rotation3.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut3 = ObjectAnimator.ofFloat(lletra3, "translationY", 0f,offsetEntrada);
			 translationOut3.setDuration(400);
			 translationOut3.setStartDelay(2500);
			 translationOut3.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY4 = ObjectAnimator.ofFloat(lletra4, "translationY", -offsetEntrada,50f,0f);
			 translationY4.setDuration(400);
			 translationY4.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation4 = ObjectAnimator.ofFloat(lletra4, "rotation", 0,360);
			 rotation4.setDuration(400);
			 rotation4.setStartDelay(1000);
			 rotation4.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut4 = ObjectAnimator.ofFloat(lletra4, "translationY", 0f,offsetEntrada);
			 translationOut4.setDuration(400);
			 translationOut4.setStartDelay(2500);
			 translationOut4.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY5 = ObjectAnimator.ofFloat(lletra5, "translationY", -offsetEntrada,50f,0f);
			 translationY5.setDuration(400);
			 translationY5.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation5 = ObjectAnimator.ofFloat(lletra5, "rotation", 0,360);
			 rotation5.setDuration(400);
			 rotation5.setStartDelay(1000);
			 rotation5.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut5 = ObjectAnimator.ofFloat(lletra5, "translationY", 0f,offsetEntrada);
			 translationOut5.setDuration(400);
			 translationOut5.setStartDelay(2500);
			 translationOut5.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY6 = ObjectAnimator.ofFloat(lletra6, "translationY", -offsetEntrada,50f,0f);
			 translationY6.setDuration(400);
			 translationY6.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation6 = ObjectAnimator.ofFloat(lletra6, "rotation", 0,360);
			 rotation6.setDuration(400);
			 rotation6.setStartDelay(1000);
			 rotation6.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut6 = ObjectAnimator.ofFloat(lletra6, "translationY", 0f,offsetEntrada);
			 translationOut6.setDuration(400);
			 translationOut6.setStartDelay(2500);
			 translationOut6.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY7 = ObjectAnimator.ofFloat(lletra7, "translationY", -offsetEntrada,50f,0f);
			 translationY7.setDuration(400);
			 translationY7.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation7 = ObjectAnimator.ofFloat(lletra7, "rotation", 0,360);
			 rotation7.setDuration(400);
			 rotation7.setStartDelay(1000);
			 rotation7.setInterpolator(new LinearInterpolator());
			 ObjectAnimator translationOut7 = ObjectAnimator.ofFloat(lletra7, "translationY", 0f,offsetEntrada);
			 translationOut7.setDuration(400);
			 translationOut7.setStartDelay(2500);
			 translationOut7.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY8 = ObjectAnimator.ofFloat(lletra8, "translationY", -offsetEntrada,50f,0f);
			 translationY8.setDuration(400);
			 translationY8.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation8 = ObjectAnimator.ofFloat(lletra8, "rotation", 0,360);
			 rotation8.setDuration(400);
			 rotation8.setStartDelay(1000);
			 rotation8.setInterpolator(new LinearInterpolator());	
			 ObjectAnimator translationOut8 = ObjectAnimator.ofFloat(lletra8, "translationY", 0f,offsetEntrada);
			 translationOut8.setDuration(400);
			 translationOut8.setStartDelay(2500);
			 translationOut8.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY9 = ObjectAnimator.ofFloat(lletra9, "translationY", -offsetEntrada,50f,0f);
			 translationY9.setDuration(400);
			 translationY9.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation9 = ObjectAnimator.ofFloat(lletra9, "rotation", 0,360);
			 rotation9.setDuration(400);
			 rotation9.setStartDelay(1000);
			 rotation9.setInterpolator(new LinearInterpolator());
			 ObjectAnimator translationOut9 = ObjectAnimator.ofFloat(lletra9, "translationY", 0f,offsetEntrada);
			 translationOut9.setDuration(400);
			 translationOut9.setStartDelay(2500);
			 translationOut9.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY10 = ObjectAnimator.ofFloat(lletra10, "translationY", -offsetEntrada,50f,0f);
			 translationY10.setDuration(400);
			 translationY10.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation10 = ObjectAnimator.ofFloat(lletra10, "rotation", 0,360);
			 rotation10.setDuration(400);
			 rotation10.setStartDelay(1000);
			 rotation10.setInterpolator(new LinearInterpolator());
			 ObjectAnimator translationOut10 = ObjectAnimator.ofFloat(lletra10, "translationY", 0f,offsetEntrada);
			 translationOut10.setDuration(400);
			 translationOut10.setStartDelay(2500);
			 translationOut10.setInterpolator(new AccelerateInterpolator());
			 ObjectAnimator translationY11 = ObjectAnimator.ofFloat(lletra11, "translationY", -offsetEntrada,50f,0f);
			 translationY11.setDuration(400);
			 translationY11.setInterpolator(new DecelerateInterpolator());
			 ObjectAnimator rotation11 = ObjectAnimator.ofFloat(lletra11, "rotation", 0,360);
			 rotation11.setDuration(400);
			 rotation11.setStartDelay(1000);
			 rotation11.setInterpolator(new LinearInterpolator());
			 ObjectAnimator translationOut11 = ObjectAnimator.ofFloat(lletra11, "translationY", 0f,offsetEntrada);
			 translationOut11.setDuration(400);
			 translationOut11.setStartDelay(2500);
			 translationOut11.setInterpolator(new AccelerateInterpolator());
			
			 AnimatorSet translate1= new AnimatorSet();
			 final AnimatorSet translate2= new AnimatorSet();
			 final AnimatorSet translate3= new AnimatorSet();
			 final AnimatorSet translate4= new AnimatorSet();
			 final AnimatorSet translate5= new AnimatorSet();
			 final AnimatorSet translate6= new AnimatorSet();
			 final AnimatorSet translate7= new AnimatorSet();
			 final AnimatorSet translate8= new AnimatorSet();
			 final AnimatorSet translate9= new AnimatorSet();
			 final AnimatorSet translate10= new AnimatorSet();
			 final AnimatorSet translate11= new AnimatorSet();
			 translate1.play(translationY).with(rotation1).with(translationOut1);
			 translate2.play(translationY2).with(rotation2).with(translationOut2);
			 translate3.play(translationY3).with(rotation3).with(translationOut3);
			 translate4.play(translationY4).with(rotation4).with(translationOut4);
			 translate5.play(translationY5).with(rotation5).with(translationOut5);
			 translate6.play(translationY6).with(rotation6).with(translationOut6);
			 translate7.play(translationY7).with(rotation7).with(translationOut7);
			 translate8.play(translationY8).with(rotation8).with(translationOut8);
			 translate9.play(translationY9).with(rotation9).with(translationOut9);
			 translate10.play(translationY10).with(rotation10).with(translationOut10);
			 translate11.play(translationY11).with(rotation11).with(translationOut11);			 
			 translate1.addListener(new AnimatorListenerAdapter() {		
			         @Override
			         public void onAnimationStart(Animator animation) {
			        	 lletra1.setVisibility(View.VISIBLE);
			         }		        
			       });
			 translate2.addListener(new AnimatorListenerAdapter() {			
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra2.setVisibility(View.VISIBLE);
		         }	        
		       });
			 translate3.addListener(new AnimatorListenerAdapter() {			
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra3.setVisibility(View.VISIBLE);
		         }	        
		       });
			 translate4.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra4.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate5.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra5.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate6.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra6.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate7.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra7.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate8.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra8.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate9.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra9.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate10.addListener(new AnimatorListenerAdapter() {	
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra10.setVisibility(View.VISIBLE);
		         }
		        
		       });
			 translate11.addListener(new AnimatorListenerAdapter() {	
				  @Override
	              public void onAnimationEnd(Animator animation) {
	            	c.finishSplash(Fragment_Splash.this);
	              }
		         @Override
		         public void onAnimationStart(Animator animation) {
		        	 lletra11.setVisibility(View.VISIBLE);
		         }
		        
		       });
			
			 translate1.start();
			  Handler handler = new Handler(); 
			    handler.postDelayed(new Runnable() { 
			         public void run() { 	
			        	 translate2.start();
			        	 Handler handler = new Handler(); 
			 		    handler.postDelayed(new Runnable() { 
			 		         public void run() { 	
			 		        	 translate3.start();
			 		        	 Handler handler = new Handler(); 
			 				    handler.postDelayed(new Runnable() { 
			 				         public void run() { 	
			 				        	 translate4.start();
			 				        	 Handler handler = new Handler(); 
			 		 				    handler.postDelayed(new Runnable() { 
			 		 				         public void run() { 
			 		 				        	 translate5.start();
					 				        	 Handler handler = new Handler(); 
					 		 				    handler.postDelayed(new Runnable() { 
					 		 				         public void run() { 
					 		 				        	 translate6.start();
							 				        	 Handler handler = new Handler(); 
							 		 				    handler.postDelayed(new Runnable() { 
							 		 				         public void run() { 
							 		 				        	 translate7.start();
									 				        	 Handler handler = new Handler(); 
									 		 				    handler.postDelayed(new Runnable() { 
									 		 				         public void run() { 
									 		 				        	 translate8.start();
											 				        	 Handler handler = new Handler(); 
											 		 				    handler.postDelayed(new Runnable() { 
											 		 				         public void run() { 
											 		 				        	 translate9.start();
													 				        	 Handler handler = new Handler(); 
													 		 				    handler.postDelayed(new Runnable() { 
													 		 				         public void run() { 
													 		 				        	 translate10.start();
															 				        	 Handler handler = new Handler(); 
															 		 				    handler.postDelayed(new Runnable() { 
															 		 				         public void run() { 
															 		 				        	 translate11.start();
																	 				        	 Handler handler = new Handler(); 
																	 		 				    handler.postDelayed(new Runnable() { 
																	 		 				         public void run() { 
																	 		 				        	 
																	 		 				        	
																	 		 				         } 
																	 		 				    }, 25); 
															 		 				        	
															 		 				         } 
															 		 				    }, 25); 
													 		 				        	
													 		 				         } 
													 		 				    }, 25); 
											 		 				        	
											 		 				         } 
											 		 				    }, 25); 
									 		 				        	
									 		 				         } 
									 		 				    }, 25); 
							 		 				        	
							 		 				         } 
							 		 				    }, 25); 
					 		 				        	
					 		 				         } 
					 		 				    }, 25); 
			 		 				        	
			 		 				         } 
			 		 				    }, 25); 
			 				        	
			 				         } 
			 				    }, 25); 
			 		         } 
			 		    }, 25); 
			        	
			         } 
			    }, 25);  
	  }
	  @Override   
	 	 public void onDestroyView() {  
			  Handler handler = new Handler(); 
			    handler.postDelayed(new Runnable() { 
			         public void run() { 	        	 
			       	  if (fondo!=null) fondo.setImageBitmap(null);
			       	  if (lletra1!=null)  lletra1.clearAnimation();
			       	if (lletra2!=null)  lletra2.clearAnimation();
			       	if (lletra3!=null)  lletra3.clearAnimation();
			       	if (lletra4!=null)  lletra4.clearAnimation();
			       	if (lletra5!=null)  lletra5.clearAnimation();
			       	if (lletra6!=null)  lletra6.clearAnimation();
			       	if (lletra7!=null)  lletra7.clearAnimation();
			       	if (lletra8!=null)  lletra8.clearAnimation();
			       	if (lletra9!=null)  lletra9.clearAnimation();
			       	if (lletra10!=null)  lletra10.clearAnimation();
			       	if (lletra11!=null)  lletra11.clearAnimation();
			         } 
			    }, 1000);
	 		 super.onDestroyView();
	 	}	
}
