package com.kronoscards.pack;

import com.kronoscards.kcmain.MainActivity;

import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.util.DisplayMetrics;
import android.util.Log;

public class AppValors {

	Context c;
	
	//Dades generals
	int screenWidth=0;
	int screenHeight=0;
	 private boolean isXxhdpi=false,isXhdpi=false,isHdpi=false,isMdpi=false,isSldpi=false;
	public int getScreenWidth() {
		return screenWidth;
	}
	public void setScreenWidth(int screenWidth) {
		this.screenWidth = screenWidth;
	}
	public int getScreenHeight() {
		return screenHeight;
	}
	public void setScreenHeight(int screenHeight) {
		this.screenHeight = screenHeight;
	}
	
	
	public boolean isXxhdpi() {
		return isXxhdpi;
	}
	public boolean isXhdpi() {
		return isXhdpi;
	}
	public boolean isHdpi() {
		return isHdpi;
	}
	public boolean isMdpi() {
		return isMdpi;
	}
	public boolean isSldpi() {
		return isSldpi;
	}


	//Animacions de fragments
	float qttTranslate=0;
	public float getQttTranslate() {
		return qttTranslate;
	}
	public void setQttTranslate(float qttTranslate) {
		this.qttTranslate = qttTranslate;
	}
	int maxElementsInScrollWindow=3;
	
	
	public int getMaxElementsInScrollWindow() {
		return maxElementsInScrollWindow;
	}
	public void setMaxElementsInScrollWindow(int maxElementsInScrollWindow) {
		this.maxElementsInScrollWindow = maxElementsInScrollWindow;
	}


	//Tipografies
	 Typeface tipoPacifico,tipoMyriad,tipoFolkNormal,tipoLittleDays;
	public Typeface getTipoPacifico() {
		return tipoPacifico;
	}
	public void setTipoPacifico(Typeface tipoPacifico) {
		this.tipoPacifico = tipoPacifico;
	}
	public Typeface getTipoMyriad() {
		return tipoMyriad;
	}
	public void setTipoMyriad(Typeface tipoMyriad) {
		this.tipoMyriad = tipoMyriad;
	}
	
	
	public Typeface getTipoFolkNormal() {
		return tipoFolkNormal;
	}
	public void setTipoFolkNormal(Typeface tipoFolkNormal) {
		this.tipoFolkNormal = tipoFolkNormal;
	}
	public Typeface getTipoLittleDays() {
		return tipoLittleDays;
	}
	public void setTipoLittleDays(Typeface tipoLittleDays) {
		this.tipoLittleDays = tipoLittleDays;
	}
	
	//SharedPreferences
		SharedPreferences prefsKC;
	public void init(Context c) {
		prefsKC= c.getSharedPreferences("PrefsKC",Context.MODE_PRIVATE);
		 DisplayMetrics metrics = new DisplayMetrics();
	        ((MainActivity)c).getWindowManager().getDefaultDisplay().getMetrics(metrics);
	        screenHeight=metrics.heightPixels;  
	        switch(metrics.densityDpi)         
	         {      
	         case DisplayMetrics.DENSITY_XXHIGH: //HDPI
	        	 isXxhdpi=true;	 
	        	 break;
	         case DisplayMetrics.DENSITY_XHIGH: //HDPI
	        	 isXhdpi=true;	 
		         	break;  
			         case DisplayMetrics.DENSITY_HIGH: //HDPI
			        	 isHdpi=true;
			         	break;         
			         case DisplayMetrics.DENSITY_MEDIUM: //MDPI
			        	 isMdpi=true;
			         	break;           
			         	case DisplayMetrics.DENSITY_LOW:  //LDPI
			         		isSldpi=true;
			         	break;  
			         	default: isHdpi=true;
			        	 break;
			         		
			         	}
		tipoPacifico=Typeface.createFromAsset(c.getAssets(), "fonts/Pacifico.ttf");
		tipoMyriad=Typeface.createFromAsset(c.getAssets(), "fonts/MyriadPro-Regular.otf");
		tipoFolkNormal=Typeface.createFromAsset(c.getAssets(), "fonts/Folks-Normal.ttf");
		tipoLittleDays=Typeface.createFromAsset(c.getAssets(), "fonts/little_days.ttf");
	}
	public SharedPreferences getPrefsKC() {
		return prefsKC;
	}
	 
	
	
}
