package com.kronoscards.pack;

import java.util.ArrayList;
import java.util.List;


public class InfoPartida {

	OpcionsPartida opcions=new OpcionsPartida();
	
	
	int numMissatge=0;
	int puntuacioCreador=0;
	int puntuacioRival=0;
	
	//Partida no iniciada
	Integer[] cartesInicial;
	List<Integer> cardsPerRepartir=new ArrayList<Integer>();
	boolean cartesRebudesByOther=false;
	
	//Partida
	List<Integer> listCardsInGame=new ArrayList<Integer>();
	int turnCounter=1;
	boolean errorTurn=false;
	int idCartaAnterior=-1;
	int positionCartaAnterior=-1;
	
	 List<Integer> listCardsByCreator=new ArrayList<Integer>();
	 List<Integer> listCardsByOtherPlayer=new ArrayList<Integer>();
	 
	 //Estats finals de partida
	 boolean stateFinishGame=false;
	 boolean stateWaitingLastJugada=false;
	 boolean stateInDesempate=false;
	
	//Desempate
	boolean enterModeDesempate=false;

	
	
	public int getPuntuacioCreador() {
		return puntuacioCreador;
	}

	public void setPuntuacioCreador(int puntuacioCreador) {
		this.puntuacioCreador = puntuacioCreador;
	}

	public int getPuntuacioRival() {
		return puntuacioRival;
	}

	public void setPuntuacioRival(int puntuacioRival) {
		this.puntuacioRival = puntuacioRival;
	}

	public int getNumMissatge() {
		return numMissatge;
	}

	public void setNumMissatge(int numMissatge) {
		this.numMissatge = numMissatge;
	}

	public boolean isCartesRebudesByOther() {
		return cartesRebudesByOther;
	}

	public void setCartesRebudesByOther(boolean cartesRebudesByOther) {
		this.cartesRebudesByOther = cartesRebudesByOther;
	}

	public OpcionsPartida getOpcions() {
		return opcions;
	}

	public void setOpcions(OpcionsPartida opcions) {
		this.opcions = opcions;
	}

	public Integer[] getCartesInicials() {
		return cartesInicial;
	}

	public void setCartesInicials(Integer[] cartesInicial) {
		this.cartesInicial = cartesInicial;
	}

	

	public List<Integer> getCardsPerRepartir() {
		return cardsPerRepartir;
	}

	public void setCardsPerRepartir(List<Integer> cardsPerRepartir) {
		this.cardsPerRepartir = cardsPerRepartir;
	}

	public List<Integer> getListCardsInGame() {
		return listCardsInGame;
	}

	public void clearCartesARepartir()
	{
		if (cardsPerRepartir!=null&&cardsPerRepartir.size()>0)
		cardsPerRepartir.clear();
	}
	public void setListCardsInGame(List<Integer> listCardsInGame) {
		this.listCardsInGame = listCardsInGame;
	}
	public void addCardGame(Integer idCard)
	{
		listCardsInGame.add(idCard);
	}

	public int getTurnCounter() {
		return turnCounter;
	}

	public void setTurnCounter(int turnCounter) {
		this.turnCounter = turnCounter;
	}

	public boolean isErrorTurn() {
		return errorTurn;
	}

	public void setErrorTurn(boolean errorTurn) {
		this.errorTurn = errorTurn;
	}

	public int getIdCartaAnterior() {
		return idCartaAnterior;
	}

	public void setIdCartaAnterior(int idCartaAnterior) {
		this.idCartaAnterior = idCartaAnterior;
	}

	public int getPositionCartaAnterior() {
		return positionCartaAnterior;
	}

	public void setPositionCartaAnterior(int positionCartaAnterior) {
		this.positionCartaAnterior = positionCartaAnterior;
	}

	public boolean isStateFinishGame() {
		return stateFinishGame;
	}

	public void setStateFinishGame(boolean finishGame) {
		this.stateFinishGame = finishGame;
	}

	public boolean isStateWaitingLastJugada() {
		return stateWaitingLastJugada;
	}

	public void setStateWaitingLastJugada(boolean stateWaitingLastJugada) {
		this.stateWaitingLastJugada = stateWaitingLastJugada;
	}

	public boolean isStateInDesempate() {
		return stateInDesempate;
	}

	public void setStateInDesempate(boolean stateInDesempate) {
		this.stateInDesempate = stateInDesempate;
	}

	
	public boolean isEnterModeDesempate() {
		return enterModeDesempate;
	}

	public void setEnterModeDesempate(boolean enterModeDesempate) {
		this.enterModeDesempate = enterModeDesempate;
	}

	public List<Integer> getListCardsByCreator() {
		return listCardsByCreator;
	}

	public void setListCardsByCreator(List<Integer> listCardsByCreator) {
		this.listCardsByCreator = listCardsByCreator;
	}

	public List<Integer> getListCardsByOtherPlayer() {
		return listCardsByOtherPlayer;
	}

	public void setListCardsByOtherPlayer(List<Integer> listCardsByOtherPlayer) {
		this.listCardsByOtherPlayer = listCardsByOtherPlayer;
	}
	
}
