package com.kronoscards.pack;



import com.kronoscards.kcmain.MainActivity;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiManager;
import android.telephony.TelephonyManager;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.AdapterView;

public class Utilitats {

	
	 public void disableEnableControls(boolean enable, ViewGroup vg){
		    for (int i = 0; i < vg.getChildCount(); i++){
		       View child = vg.getChildAt(i);
		       child.setEnabled(enable);
		       if (child instanceof ViewGroup){ 
		          disableEnableControls(enable, (ViewGroup)child);
		       }
		    }
		}	
	 
	 public void unbindDrawables(View view) {
		 if (view == null) { return; }
		 if (view.getBackground() != null) { view.getBackground().setCallback(null); }

		 if (view instanceof ViewGroup) {
		     for (int i = 0; i < ((ViewGroup) view).getChildCount(); i++) { 
		     	unbindDrawables(((ViewGroup) view).getChildAt(i));
		     	}
		     if (!(view instanceof AdapterView)) { 
		     	((ViewGroup) view).removeAllViews(); 
		     	}
		 }
	 }
	 boolean conexio=false;
		private Context c;
		private String phoneType="";
		
		 public boolean getConnexio(Context c) {      
			 this.c=c;
			 findDeviceType();
			 return isNetworkAvailable();
		    }
		
		 public String getPhoneType(Context c)
		 {
			 this.c=c;
			 findDeviceType();
			 return phoneType;
		 }
		 public String getDeviceUid(Context c)
		 {
			 this.c=c;
			 String uid=findDeviceID();
				 if (uid.contains(":")) uid=uid.replaceAll(":", "");
			 return  uid;
		 }
		 
		 private boolean isNetworkAvailable() 
		 { 	 
		 	ConnectivityManager connectivity = (ConnectivityManager) c.getSystemService(Context.CONNECTIVITY_SERVICE); 
		 	if (connectivity != null)
		 	{	 
		 		NetworkInfo[] info = connectivity.getAllNetworkInfo(); 
		 		if (info != null) 
		 		{ 			
		 			for (int i = 0; i < info.length; i++) 
		 			{ 
		 				if (phoneType.compareTo("NONE")==0)
		 				{
		 					if (info[i].getTypeName().toLowerCase().compareTo("wifi")==0)
		 					{					
		 						if (info[i].getState() == NetworkInfo.State.CONNECTED) 
		 						{				
		 							return true; 
		 						}
		 					}
		 				}
		 				else
		 				{
		 					if (info[i].getState() == NetworkInfo.State.CONNECTED) 
		 					{						 
		 						return true; 
		 					}
		 				}
		 				} 
		 			} 
		 		} 
		 	return false; 
		 	}    
		 public void findDeviceType() {	   
		     String serviceName = Context.TELEPHONY_SERVICE;
		     TelephonyManager m_telephonyManager = (TelephonyManager) c.getSystemService(serviceName);
		     int deviceType = m_telephonyManager.getPhoneType();
		    
		     switch (deviceType) {
		           case (TelephonyManager.PHONE_TYPE_GSM):
		        	   this.phoneType="GSM";
		           break;
		           case (TelephonyManager.PHONE_TYPE_CDMA):
		        	   this.phoneType="CDMA";
		           break;
		           case (TelephonyManager.PHONE_TYPE_NONE):
		        	   this.phoneType="NONE";
		        	break;	        
		     }
		}
		 public String findDeviceID() {
			     String deviceID = null;
			     String serviceName = Context.TELEPHONY_SERVICE;
			     TelephonyManager m_telephonyManager = (TelephonyManager) c.getSystemService(serviceName);
			     int deviceType = m_telephonyManager.getPhoneType();
			     switch (deviceType) {
			           case (TelephonyManager.PHONE_TYPE_GSM):	   	            	
			        	    deviceID = m_telephonyManager.getDeviceId();
			           break;
			           case (TelephonyManager.PHONE_TYPE_CDMA):
			        	   deviceID = m_telephonyManager.getDeviceId();
			           break;
			           case (TelephonyManager.PHONE_TYPE_NONE):
			        	   WifiManager wimanager = (WifiManager)c.getSystemService(Context.WIFI_SERVICE);
			           if (wimanager!=null) deviceID= wimanager.getConnectionInfo().getMacAddress();
			           else deviceID="Error";	           
			           break;
			          default:deviceID=m_telephonyManager.getDeviceId();;
			         break;	        
			     }
			     return deviceID;
			}
		  // Sets the flag to keep this screen on. It's recommended to do that during
		    // the
		    // handshake when setting up a game, because if the screen turns off, the
		    // game will be
		    // cancelled.
		    public void keepScreenOn(Context c) {
		        ((MainActivity)c).getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		    }

		    // Clears the flag that keeps the screen on.
		    public void stopKeepingScreenOn(Context c) {
		    	((MainActivity)c).getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		    }
		 
}
