package com.kronoscards.adaptscreen;

import java.util.ArrayList;

import com.kronoscards.kcmain.R;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.GradientDrawable;
import android.util.Log;


public class GradientsKronos {
	
	
	public static ArrayList<GradientColorKronos> list = new ArrayList<GradientColorKronos>();
	
	static Bitmap bm;
	public void init(Context c)
	{
		bm=BitmapFactory.decodeResource(c.getResources(), R.drawable.gradient2);
		for (int i=0;i<255;i++)
		{
			list.add(generateColor(i));
		}
		//list.add(generateColor(254));
	}
	
	public ArrayList<GradientColorKronos> getListGradients()
	{
		return list;
	}
	private static GradientColorKronos generateColor(int position)
	{
		//Log.v("Colors","Position= "+position);
		 int pixel1 = bm.getPixel(position,0);
	        int redValue1 = Color.red(pixel1);
	        int blueValue1 = Color.blue(pixel1);
	        int greenValue1 = Color.green(pixel1);
	        int pixel2 = bm.getPixel(position,bm.getHeight()-5);
	        int redValue2 = Color.red(pixel2);
	        int blueValue2 = Color.blue(pixel2);
	        int greenValue2 = Color.green(pixel2);
	        //Log.v("Colors","redValue1= "+redValue1+" blueValue1= "+blueValue1+ "  greenValue1= "+greenValue1);
	        //Log.v("Colors","redValue2= "+redValue2+" blueValue2= "+blueValue2+ "  greenValue2= "+greenValue2);
	        return new GradientColorKronos(position,Color.argb(255, redValue1, greenValue1,blueValue1),Color.argb(255, redValue2, greenValue2,blueValue2),Color.WHITE);
		/*int red=0+(position);
		int green=0+(position);
		int blue=0+(position);
		int red2=0+(position+20);
		int green2=0+(position+20);
		int blue2=0+(position+20);
		Color color1=Color.argb(255, red2, green2, blue2)
		return newGradientColorKronos(positon,0x)*/
	}
	public static GradientDrawable NewGradient(GradientColorKronos gc,float cornerRadius,int strokeWitch,int strokeColor) {
		GradientDrawable gd = new GradientDrawable(GradientDrawable.Orientation.TOP_BOTTOM, new int[] {gc.getColorA(), gc.getColorB() });
		//gd.setGradientType(GradientDrawable.RADIAL_GRADIENT);
		//gd.setGradientCenter(20.0f, 50f);
		gd.setCornerRadius(cornerRadius);
		//gd.setStroke(strokeWitch, gc.getColorE());
		gd.setStroke(strokeWitch, strokeColor);
		return gd;
	}
}
