package com.kronoscards.fragments;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.kronoscards.adaptscreen.OutlineTextView;
import com.kronoscards.kcmain.MainActivity;
import com.kronoscards.kcmain.R;

public class Fragment_OpcionsPartida extends Fragment {
	
	 MainActivity p;
	 View view;
	 ImageView checksonido,checkdesempate;
	 boolean isSonido=true;
	 boolean isDemempate=false;
	 TextView textDificultat,textPaquete,textMaxNumCards,textCardsInMano,textCardsInTablero,textTiempo;
	 String[] listDificultat=new String[]{"Facil","Medio","Difcil"};
	 String[] paqueteCartas=new String[]{"Todas","Descubrimientos cientficos","Inventos","Eventos"};
	 String[] maxNumCartes=new String[]{"10","15","20"};
	 String[] maxCartesEnMano=new String[]{"1","2","3","4","5"};
	 String[] cartasIniciales=new String[]{"1","2","3","4","5"};
	 String[] tiempoTurno=new String[]{"30","45","60"};
	 
	  @Override
	   public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		       view = inflater.inflate(R.layout.fragment_opcions, container, false);
		       p=(MainActivity) getActivity();
		       p.setNumFragment(2);
		       OutlineTextView titulo=(OutlineTextView)view.findViewById(R.id.titulo);
		       titulo.setTypeface(p.getAppValors().getTipoPacifico());
		       titulo.setTextColor(Color.argb(255, 0, 197, 0));	
		       TextView titulosonido=(TextView)view.findViewById(R.id.titulosonido);
		       TextView titulodesempate=(TextView)view.findViewById(R.id.titulodesempate);
		       TextView titulodificultat=(TextView)view.findViewById(R.id.titulodificultat);
		       TextView titulopaquete=(TextView)view.findViewById(R.id.titulopaquete);
		       TextView titulototalcards=(TextView)view.findViewById(R.id.titulototalcards);
		       TextView titulototalcardsinma=(TextView)view.findViewById(R.id.titulototalcardsinma);
		       TextView titulototalcardsintablero=(TextView)view.findViewById(R.id.titulototalcardsintablero);
		       TextView titulotiempo=(TextView)view.findViewById(R.id.titulotiempo);
		       titulotiempo.setTypeface(p.getAppValors().getTipoMyriad());
		       titulosonido.setTypeface(p.getAppValors().getTipoMyriad());
		       titulodesempate.setTypeface(p.getAppValors().getTipoMyriad());
		       titulodificultat.setTypeface(p.getAppValors().getTipoMyriad());
		       titulopaquete.setTypeface(p.getAppValors().getTipoMyriad());
		       titulototalcards.setTypeface(p.getAppValors().getTipoMyriad());
		       titulototalcardsinma.setTypeface(p.getAppValors().getTipoMyriad());
		       titulototalcardsintablero.setTypeface(p.getAppValors().getTipoMyriad());
		       checksonido=(ImageView)view.findViewById(R.id.checksonido);
		       checkdesempate=(ImageView)view.findViewById(R.id.checkdesempate);
		       if (p.getAppValors().getPrefsKC().getBoolean("sonido", true))
		       {
		    	   checksonido.setImageResource(R.drawable.btn_ok);
		    	   isSonido=true;
		       }else
		       {
		    	   checksonido.setImageResource(R.drawable.btn_ko);
		    	   isSonido=false;
		       }
		       if (p.getAppValors().getPrefsKC().getBoolean("desempate", false))
		       {
		    	   checkdesempate.setImageResource(R.drawable.btn_ok);
		    	   isDemempate=true;
		       }else
		       {
		    	   checkdesempate.setImageResource(R.drawable.btn_ko);
		    	   isDemempate=false;
		       }
		       RelativeLayout btn_sonido=(RelativeLayout)view.findViewById(R.id.relsonido);
		       btn_sonido.setOnClickListener(new OnClickListener(){

				@Override
				public void onClick(View v) {
					if (isSonido)
					{
						 checksonido.setImageResource(R.drawable.btn_ko);
				    	   isSonido=false;
				    	   p.getAppValors().getPrefsKC().edit().putBoolean("sonido", false).commit();
					}else
					{
						 checksonido.setImageResource(R.drawable.btn_ok);
				    	   isSonido=true;
				    	   p.getAppValors().getPrefsKC().edit().putBoolean("sonido", true).commit();
			
					}
				}
		    	   
		       });
		       RelativeLayout btn_desempate=(RelativeLayout)view.findViewById(R.id.reldesempate);
		       btn_desempate.setOnClickListener(new OnClickListener(){

					@Override
					public void onClick(View v) {
						if (isDemempate)
						{
							checkdesempate.setImageResource(R.drawable.btn_ko);
							 isDemempate=false;
					    	   p.getAppValors().getPrefsKC().edit().putBoolean("desempate", false).commit();
						}else
						{
							checkdesempate.setImageResource(R.drawable.btn_ok);
							 isDemempate=true;
					    	   p.getAppValors().getPrefsKC().edit().putBoolean("desempate", true).commit();
				
						}
					}
			    	   
			       });
		       textDificultat=(TextView)view.findViewById(R.id.textodificultat);
		       textDificultat.setTypeface(p.getAppValors().getTipoMyriad());
		       int dificultat=p.getAppValors().getPrefsKC().getInt("dificultat", 1);
		       textDificultat.setText(listDificultat[dificultat]);
		        RelativeLayout btn_dificultat=(RelativeLayout)view.findViewById(R.id.reldificultat);
		       btn_dificultat.setOnClickListener(new OnClickListener(){

					@Override
					public void onClick(View v) {
						 AlertDialog.Builder alt_bld = new AlertDialog.Builder(p);
				            alt_bld.setTitle("Dificultat:");
				            alt_bld.setSingleChoiceItems(listDificultat, -1, new DialogInterface.OnClickListener() {
				                public void onClick(DialogInterface dialog, int item) {
				                	if (item!=-1)
		     	                	{
				                		int dificultat=item;
				                		 textDificultat.setText(listDificultat[dificultat]);
				                		 p.getAppValors().getPrefsKC().edit().putInt("dificultat", dificultat).commit();			     	                
		     	                	}
				                	dialog.dismiss();
				                }
				            });
				            AlertDialog alert = alt_bld.create();
				            alert.show();
					}
			    	   
			       });
		       textPaquete=(TextView)view.findViewById(R.id.textopaquete);
		       textPaquete.setTypeface(p.getAppValors().getTipoMyriad());
		       int paquete=p.getAppValors().getPrefsKC().getInt("paquete", 0);
		       textPaquete.setText(paqueteCartas[paquete]);
		        RelativeLayout btn_paquete=(RelativeLayout)view.findViewById(R.id.relpaquete);
		        btn_paquete.setOnClickListener(new OnClickListener(){

					@Override
					public void onClick(View v) {
						 AlertDialog.Builder alt_bld = new AlertDialog.Builder(p);
				            alt_bld.setTitle("Pack de cartas:");
				            alt_bld.setSingleChoiceItems(paqueteCartas, -1, new DialogInterface.OnClickListener() {
				                public void onClick(DialogInterface dialog, int item) {
				                	if (item!=-1)
		     	                	{
				                		 int paquete=item;
				          		       textPaquete.setText(paqueteCartas[paquete]);
				                		 p.getAppValors().getPrefsKC().edit().putInt("paquete", paquete).commit();			     	                
		     	                	}
				                	dialog.dismiss();
				                }
				            });
				            AlertDialog alert = alt_bld.create();
				            alert.show();
					}
			    	   
			       });
		        textMaxNumCards=(TextView)view.findViewById(R.id.textomaxcards);
		        textMaxNumCards.setTypeface(p.getAppValors().getTipoMyriad());
			       int numCards=p.getAppValors().getPrefsKC().getInt("maxNumCards", 20);
			       textMaxNumCards.setText(""+numCards);
			        RelativeLayout btn_maxNumCards=(RelativeLayout)view.findViewById(R.id.reltotalcards);
			        btn_maxNumCards.setOnClickListener(new OnClickListener(){

						@Override
						public void onClick(View v) {
							 AlertDialog.Builder alt_bld = new AlertDialog.Builder(p);
					            alt_bld.setTitle("Cartas mximas:");
					            alt_bld.setSingleChoiceItems(maxNumCartes, -1, new DialogInterface.OnClickListener() {
					                public void onClick(DialogInterface dialog, int item) {
					                	if (item!=-1)
			     	                	{
					                		 int numCards=Integer.parseInt(maxNumCartes[item]);
					                		 textMaxNumCards.setText(""+numCards);
					                		 p.getAppValors().getPrefsKC().edit().putInt("maxNumCards", numCards).commit();			     	                
			     	                	}
					                	dialog.dismiss();
					                }
					            });
					            AlertDialog alert = alt_bld.create();
					            alert.show();
						}
				    	   
				       });
			        textCardsInMano=(TextView)view.findViewById(R.id.textomaxcardsinma);
			        textCardsInMano.setTypeface(p.getAppValors().getTipoMyriad());
				       int numCardsInMano=p.getAppValors().getPrefsKC().getInt("maxNumInMano", 4);
				       textCardsInMano.setText(""+numCardsInMano);
				        RelativeLayout btn_maxNumCardsInMano=(RelativeLayout)view.findViewById(R.id.reltotalcardsinma);
				        btn_maxNumCardsInMano.setOnClickListener(new OnClickListener(){

							@Override
							public void onClick(View v) {
								 AlertDialog.Builder alt_bld = new AlertDialog.Builder(p);
						            alt_bld.setTitle("Cartas mximas en mano:");
						            alt_bld.setSingleChoiceItems(maxCartesEnMano, -1, new DialogInterface.OnClickListener() {
						                public void onClick(DialogInterface dialog, int item) {
						                	if (item!=-1)
				     	                	{
						                		 int numCards=Integer.parseInt(maxCartesEnMano[item]);
						                		 textCardsInMano.setText(""+numCards);
						                		 p.getAppValors().getPrefsKC().edit().putInt("maxNumInMano", numCards).commit();			     	                
				     	                	}
						                	dialog.dismiss();
						                }
						            });
						            AlertDialog alert = alt_bld.create();
						            alert.show();
							}
					    	   
					       });
				        textCardsInTablero=(TextView)view.findViewById(R.id.textomaxcardsintablero);
				        textCardsInTablero.setTypeface(p.getAppValors().getTipoMyriad());
					       int numCardsInTablero=p.getAppValors().getPrefsKC().getInt("cardsInTablero", 1);
					       textCardsInTablero.setText(""+numCardsInTablero);
					        RelativeLayout btn_maxNumCardsInTablero=(RelativeLayout)view.findViewById(R.id.reltotalcardsintablero);
					        btn_maxNumCardsInTablero.setOnClickListener(new OnClickListener(){

								@Override
								public void onClick(View v) {
									 AlertDialog.Builder alt_bld = new AlertDialog.Builder(p);
							            alt_bld.setTitle("Cartas iniciales en tablero:");
							            alt_bld.setSingleChoiceItems(cartasIniciales, -1, new DialogInterface.OnClickListener() {
							                public void onClick(DialogInterface dialog, int item) {
							                	if (item!=-1)
					     	                	{
							                		 int numCards=Integer.parseInt(cartasIniciales[item]);
							                		 textCardsInTablero.setText(""+numCards);
							                		 p.getAppValors().getPrefsKC().edit().putInt("cardsInTablero", numCards).commit();			     	                
					     	                	}
							                	dialog.dismiss();
							                }
							            });
							            AlertDialog alert = alt_bld.create();
							            alert.show();
								}
						    	   
						       });
					        textTiempo=(TextView)view.findViewById(R.id.textotiempo);
					        textTiempo.setTypeface(p.getAppValors().getTipoMyriad());
						       int tiempo=p.getAppValors().getPrefsKC().getInt("tiempo", 60);
						       textTiempo.setText(""+tiempo);
						        RelativeLayout btn_tiempo=(RelativeLayout)view.findViewById(R.id.reltiempo);
						        btn_tiempo.setOnClickListener(new OnClickListener(){

									@Override
									public void onClick(View v) {
										 AlertDialog.Builder alt_bld = new AlertDialog.Builder(p);
								            alt_bld.setTitle("Cartas iniciales en tablero:");
								            alt_bld.setSingleChoiceItems(tiempoTurno, -1, new DialogInterface.OnClickListener() {
								                public void onClick(DialogInterface dialog, int item) {
								                	if (item!=-1)
						     	                	{
								                		 int numCards=Integer.parseInt(tiempoTurno[item]);
								                		 textTiempo.setText(""+numCards);
								                		 p.getAppValors().getPrefsKC().edit().putInt("tiempo", numCards).commit();			     	                
						     	                	}
								                	dialog.dismiss();
								                }
								            });
								            AlertDialog alert = alt_bld.create();
								            alert.show();
									}
							    	   
							       });
		      
		       return view;
	  }

	public void backPressed() {
		p.returnFragmentMainScreen();
		
	}

}
